#if __cplusplus
#include "tsp.hpp"
#else
#include "tsp.h"
#endif

/*LINTLIBRARY*/

#define C_implementation_file

/*
module generated from VDM Class Library
$Revision: 1.1 $
$Date: 1996/07/04 07:44:15 $
*/

#ifdef __cplusplus
#define outerrstr_vdmlib(x1) cerr << x1
#define outerrint_vdmlib(x1) cerr << x1
#define outerrme1_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
#define outerrmes_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
#else
#define outerrstr_vdmlib(x1) fprintf(stderr,"%s",x1)
#define outerrint_vdmlib(x1) fprintf(stderr,"%ld",x1)
#define outerrme1_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
#define outerrmes_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
#endif
void err_empty_iterator_vdmlib (char * x1)
{
outerrmes_vdmlib("no more elements to process by an iterator",x1);
abort_vdmlib(VDM_ERR_EMPTYIT);
}

void abort_vdmlib (Nat0 x1)
{
exit(1);
}
void heap_oflw_vdmlib (char * x1)
{
outerrmes_vdmlib("no more heap space available",x1);
abort_vdmlib(VDM_ERR_HEAPOFL);
}

Bool supress_cvlines_vdmlib = TRUE;
Nat0 curr_linelen_vdmlib;
char *start_structure_vdmlib;
char *end_structure_vdmlib;

void adj_linelen_vdmlib (Nat0 x1)
{ curr_linelen_vdmlib = (curr_linelen_vdmlib > x1) ? (curr_linelen_vdmlib - x1) : 0;}

Str ident_prefix_vdmlib (Str x1,Nat0 x2)
{ return conc_str(mkn_str(' ',x2 - len_str(x1)), x1); }

Cvtext_vdmlib ident_lines_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Str lx1;Nat1 lx2;

lx1 = mkn_str(' ',len_str(x2));
x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)1
, conc_str(x2,sel_cvtext_vdmlib(x1,(Nat1)1)));
for(lx2 = 2;lx2 <= len_cvtext_vdmlib(x1); lx2++)
x1 = ovwrt1_cvtext_vdmlib( x1
, lx2
, conc_str( copy_str(lx1)
, sel_cvtext_vdmlib(x1,lx2)));
del_str(lx1);
return x1;
}

Cvtext_vdmlib close_struct_vdmlib (Cvtext_vdmlib x1,Str x2,Nat0 x3)
{ Nat0 lx1 = len_cvtext_vdmlib(x1);
Str lx2 = sel_cvtext_vdmlib(x1,(Nat1)lx1);
Nat0 lx3 = 1;

if (lx1 <= 2)
return ovwrt1_cvtext_vdmlib(x1,(Nat1)lx1,conc_str(lx2,x2));

while(sel_str(lx2,lx3) == ' ') lx3++;
if ( len_str(x2) == 1
&& sel_str(lx2,lx3) == hd_str(x2)
)
{ return ovwrt1_cvtext_vdmlib(x1
,(Nat1)lx1
,ovwrt1_str(lx2,x3,hd_str(x2)));
}

return appr_cvtext_vdmlib(x1,ident_prefix_vdmlib(x2,x3));
}

Cvtext_vdmlib append_lastline_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (len_cvtext_vdmlib(x2) != 1)
{
outerrstr_vdmlib("error in 2nd parameter of 'append_lastline'");
abort_vdmlib(VDM_ERR_CVLINES);
}
{ Nat0 lx1 = len_cvtext_vdmlib(x1);

x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)lx1
, conc_str( sel_cvtext_vdmlib(x1,(Nat1)lx1)
, conc_str( mkc_str(",")
, hd_cvtext_vdmlib(x2))));
del1_cvtext_vdmlib(x2);
return x1;
}
}

static Bool last_was_simple_vdmlib (Cvtext_vdmlib x1,Nat0 x2)
{ return ( len_cvtext_vdmlib(x1) == 1
|| index_str(last_cvtext_vdmlib(x1),',') == x2
);
}

Cvtext_vdmlib cvlines2_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (is_empty_cvtext_vdmlib(x1))
return ident_lines_vdmlib(x2,mkc_str(start_structure_vdmlib));
else
{ if ( len_cvtext_vdmlib(x2) == 1
&& len_str(hd_cvtext_vdmlib(x2))
+ len_str(last_cvtext_vdmlib(x1))
< curr_linelen_vdmlib
&& last_was_simple_vdmlib(x1,(Nat0)strlen(start_structure_vdmlib))
)
return append_lastline_vdmlib(x1,x2);
else
return conc_cvtext_vdmlib
(x1,ident_lines_vdmlib
(x2,ident_prefix_vdmlib( mkc_str(",")
, (Nat0)strlen(start_structure_vdmlib))));
}
}

#ifdef __cplusplus
void fprint_lines_vdmlib (ostream & x1,Cvtext_vdmlib x2)
#else
void fprint_lines_vdmlib (FILE * x1,Cvtext_vdmlib x2)
#endif
{ Nat1 lx1;

for (lx1 = 1;lx1 <= len_cvtext_vdmlib(x2); lx1++)
{ Nat1 lx3;
Str lx4;

lx4 = sel_cvtext_vdmlib(x2,lx1);
for (lx3 = 1; lx3 <= len_str(lx4); lx3++)
#ifdef __cplusplus
{x1 << (char)(sel_str(lx4,lx3));}
x1 << "\n";
#else
{fprintf(x1,"%c",sel_str(lx4,lx3));}
fprintf(x1,"\n");
#endif
}
}
void err_nv_hdl_vdmlib (char * x1)
{
outerrmes_vdmlib("accessed object contains no valid data",x1);
abort_vdmlib(VDM_ERR_NV_HDL);
}
void err_sel_vdmlib (Nat1 x1,Nat0 x2,char * x3)
{
outerrme1_vdmlib("attempt to select element",x3);
outerrint_vdmlib((long)x1);
outerrstr_vdmlib(" of tuple with length ");
outerrint_vdmlib((long)x2);
outerrstr_vdmlib("\n");
abort_vdmlib(VDM_ERR_SELECT);
}
void err_tl_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'tl' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYTL);
}
Bool and_bool (Bool x1,Bool x2)   {return x1 & x2;}
Bool is_eq_bool (Bool x1,Bool x2)   {return (x1==x2);}
Bool is_ge_bool (Bool x1,Bool x2)   {return (x1>=x2);}
Bool or_bool (Bool x1,Bool x2)   {return x1 | x2;}
Bool not_bool (Bool x1)  {return !x1;}
Bool is_gr_bool (Bool x1,Bool x2)   {return (x1>x2);}
Bool xor_bool (Bool x1,Bool x2)   {return x1 ^ x2;}
#if __cplusplus
NILETC empty, nil, new_val;
#endif
void del_real (Real x1)  {}
Real copy_real (Real x1)  {return x1;}
Real pred_real (Real x1)  { return (x1) - 1; }
Bool is_eq_real (Real x1,Real x2)   {return (x1==x2);}
Bool is_lt_real (Real x1,Real x2)   { return is_gr_real((x2),(x1)); }
Bool is_ge_real (Real x1,Real x2)   {return (x1>=x2);}
Real times_real (Real x1,Real x2)   { return (x1)*(x2); }
Real plus_real (Real x1,Real x2)   {return x1 + x2;}

#ifdef __cplusplus
void fpr_real (ostream & x1,Real x2)
#else
void fpr_real (FILE * x1,Real x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_real(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Cvtext_vdmlib cvlines_real (Real x1)
{ char lx1[50];

sprintf(lx1,printformat_real,(double)x1);
return mk1_cvtext_vdmlib(mkc_str(lx1));
}
Real succ_real (Real x1)  { return (x1) + 1; }
Bool is_le_real (Real x1,Real x2)   { return is_ge_real((x2),(x1)); }
Bool is_gr_real (Real x1,Real x2)   {return (x1>x2);}
Real div_real (Real x1,Real x2)   { return (x1)/(x2); }
Real minus_real (Real x1,Real x2)   { return (x1)-(x2); }
char * printformat_real = "%lg";

void set_print_format_real (char * x1)
{ printformat_real = (x1) ? x1 : "%lg"; }
Nat1 minus_nat1 (Nat1 x1,Nat1 x2)   { return (x1)-(x2); }
Nat1 div_nat1 (Nat1 x1,Nat1 x2)   { return (x1)/(x2); }
Bool is_gr_nat1 (Nat1 x1,Nat1 x2)   {return (x1>x2);}
Bool is_le_nat1 (Nat1 x1,Nat1 x2)   { return is_ge_nat1((x2),(x1)); }
Nat1 mod_nat1 (Nat1 x1,Nat1 x2)   { return (x1)%(x2); }
Nat1 succ_nat1 (Nat1 x1)  { return (x1) + 1; }
Nat1 plus_nat1 (Nat1 x1,Nat1 x2)   {return x1 + x2;}
Nat1 times_nat1 (Nat1 x1,Nat1 x2)   { return (x1)*(x2); }
Bool is_ge_nat1 (Nat1 x1,Nat1 x2)   {return (x1>=x2);}
Bool is_lt_nat1 (Nat1 x1,Nat1 x2)   { return is_gr_nat1((x2),(x1)); }
Bool is_eq_nat1 (Nat1 x1,Nat1 x2)   {return (x1==x2);}
Nat1 pred_nat1 (Nat1 x1)  { return (x1) - 1; }
Nat0 minus_nat0 (Nat0 x1,Nat0 x2)   { return (x1)-(x2); }
Nat0 div_nat0 (Nat0 x1,Nat0 x2)   { return (x1)/(x2); }
Bool is_gr_nat0 (Nat0 x1,Nat0 x2)   {return (x1>x2);}
Bool is_le_nat0 (Nat0 x1,Nat0 x2)   { return is_ge_nat0((x2),(x1)); }
Nat0 mod_nat0 (Nat0 x1,Nat0 x2)   { return (x1)%(x2); }
Nat0 succ_nat0 (Nat0 x1)  { return (x1) + 1; }
Nat0 plus_nat0 (Nat0 x1,Nat0 x2)   {return x1 + x2;}
Nat0 times_nat0 (Nat0 x1,Nat0 x2)   { return (x1)*(x2); }
Bool is_ge_nat0 (Nat0 x1,Nat0 x2)   {return (x1>=x2);}
Bool is_lt_nat0 (Nat0 x1,Nat0 x2)   { return is_gr_nat0((x2),(x1)); }
Bool is_eq_nat0 (Nat0 x1,Nat0 x2)   {return (x1==x2);}
Nat0 pred_nat0 (Nat0 x1)  { return (x1) - 1; }
Intg minus_intg (Intg x1,Intg x2)   { return (x1)-(x2); }
Intg div_intg (Intg x1,Intg x2)   { return (x1)/(x2); }
Bool is_gr_intg (Intg x1,Intg x2)   {return (x1>x2);}
Bool is_le_intg (Intg x1,Intg x2)   { return is_ge_intg((x2),(x1)); }
Intg mod_intg (Intg x1,Intg x2)   { return (x1)%(x2); }
Intg succ_intg (Intg x1)  { return (x1) + 1; }
Intg plus_intg (Intg x1,Intg x2)   {return x1 + x2;}
Intg times_intg (Intg x1,Intg x2)   { return (x1)*(x2); }
Bool is_ge_intg (Intg x1,Intg x2)   {return (x1>=x2);}
Bool is_lt_intg (Intg x1,Intg x2)   { return is_gr_intg((x2),(x1)); }
Bool is_eq_intg (Intg x1,Intg x2)   {return (x1==x2);}
Intg pred_intg (Intg x1)  { return (x1) - 1; }
void del_char (Char x1)  {}
Char minus_char (Char x1,Char x2)   { return (x1)-(x2); }
Char div_char (Char x1,Char x2)   { return (x1)/(x2); }
Bool is_gr_char (Char x1,Char x2)   {return (x1>x2);}
Bool is_le_char (Char x1,Char x2)   { return is_ge_char((x2),(x1)); }
Char mod_char (Char x1,Char x2)   { return (x1)%(x2); }
Char succ_char (Char x1)  { return (x1) + 1; }
Char plus_char (Char x1,Char x2)   {return x1 + x2;}
Char times_char (Char x1,Char x2)   { return (x1)*(x2); }
Bool is_ge_char (Char x1,Char x2)   {return (x1>=x2);}
Bool is_lt_char (Char x1,Char x2)   { return is_gr_char((x2),(x1)); }
Bool is_eq_char (Char x1,Char x2)   {return (x1==x2);}
Char pred_char (Char x1)  { return (x1) - 1; }
Char copy_char (Char x1)  {return x1;}

Cvtext_vdmlib alloc_cvtext_vdmlib (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_cvtext_vdmlib) + (x1 + 0) * sizeof(Str);
Nat0 len2 = 4;
Cvtext_vdmlib lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Cvtext_vdmlib) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Cvtext_vdmlib");
lx1->f_max = ((len2 - sizeof(struct Struct_cvtext_vdmlib))/sizeof(Str));
lx1->f_len = x1;
;
;
return lx1;
}

void free_cvtext_vdmlib (Cvtext_vdmlib x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_cvtext_vdmlib) + x1->f_max*sizeof(Str));
}

Rep_str alloc_rep_str (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_str) + (x1 + 0) * sizeof(Char);
Nat0 len2 = 4;
Rep_str lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_str) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_str");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_str))/sizeof(Char));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_str (Rep_str x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_str) + x1->f_max*sizeof(Char));
}

Iter_rep_population mk_iter_rep_population (Rep_population x1)  {
Iter_rep_population lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_population (Iter_rep_population * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_population");
x1->f_curser++;
}

Chromosom sel_iter_rep_population (Iter_rep_population * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_population");

return
*(((Chromosom *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_chromosom mk_iter_rep_chromosom (Rep_chromosom x1)  {
Iter_rep_chromosom lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_chromosom (Iter_rep_chromosom * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_chromosom");
x1->f_curser++;
}

Real sel_iter_rep_chromosom (Iter_rep_chromosom * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_chromosom");

return
*(((Real *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_zeile mk_iter_rep_zeile (Rep_zeile x1)  {
Iter_rep_zeile lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_zeile (Iter_rep_zeile * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_zeile");
x1->f_curser++;
}

Spalte sel_iter_rep_zeile (Iter_rep_zeile * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_zeile");

return
*(((Spalte *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_spalte mk_iter_rep_spalte (Rep_spalte x1)  {
Iter_rep_spalte lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_spalte (Iter_rep_spalte * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_spalte");
x1->f_curser++;
}

Real sel_iter_rep_spalte (Iter_rep_spalte * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_spalte");

return
*(((Real *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_fitness mk_iter_rep_fitness (Rep_fitness x1)  {
Iter_rep_fitness lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_fitness (Iter_rep_fitness * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_fitness");
x1->f_curser++;
}

Real sel_iter_rep_fitness (Iter_rep_fitness * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_fitness");

return
*(((Real *)(x1->f_array +1)) + x1->f_curser);
}

static Nat0 len_mfree_str = 0;

static Nat0 cnt_alloc_str = 0;
static Nat0 cnt_free_str = 0;
static Nat0 cnt_mallc_str = 0;
static Nat0 cnt_mfree_str = 0;

void profile_str (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Str");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_str);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_str);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_str);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_str);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_str);
fprintf(stderr,"\n");
}

static VOIDptr freelist_str = (VOIDptr)0;

Str alloc_str (void)
{Str x1;
cnt_alloc_str ++;
if (! freelist_str)
{while (! (x1 = (Str)ALLOCMEM_vdmlib(sizeof(struct Handle_str)))) heap_oflw_vdmlib("Heap_str");
cnt_mallc_str ++;
return x1;
}
freelist_str = *((VOIDptr *)(x1 = (Str) freelist_str));
len_mfree_str --;
return x1;
}

void free_str (Str x1)
{len_mfree_str ++;
cnt_free_str ++;
*((VOIDptr *)x1) = freelist_str;
freelist_str = (VOIDptr)x1;
if (len_mfree_str > 100)
{while (len_mfree_str > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_str);
FREEMEM_vdmlib(freelist_str,sizeof(struct Handle_str));
freelist_str = lx1;
len_mfree_str --;
cnt_mfree_str ++;
}
}
}

void forall_rep_str (Rep_str x1,T2_forall_rep_str x2)
{Nat0 lx1 = ref_rep_str(x1)->f_len;
Char * px1 = (Char * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}
void del1_rep_str (Rep_str x1)  {free_rep_str(x1);}

Rep_str mknc_rep_str (Char x1,Nat0 x2)
{ Rep_str y1 = alloc_rep_str(x2);
Char* y2 = ((Char *)(y1 + 1));

while(x2--) { *(y2++) = copy_char(x1); }
return y1;
}

Rep_str ovwrt1d_rep_str (Rep_str x1,Nat1 x2,Char x3)
{
if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
;
*( ((Char *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_str conc_rep_str (Rep_str x1,Rep_str x2)
{Nat0 ll1 = ref_rep_str(x1)->f_len;
Nat0 ll = ll1 + ref_rep_str(x2)->f_len;
if (ll > x1->f_max)
{Rep_str lx3 = alloc_rep_str(ll);
register Nat0 i = ll1;
register Char * px3 = (Char *)(lx3 + 1);
register Char * px1 = (Char *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_str(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Char * px1 = ((Char *)( x1 + 1)) + ll1;
register Char * px2 = (Char *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_str(x2);
}
return x1;
}

void cpc_rep_str (Rep_str x1,Char * x2)
{register Nat0 li = ref_rep_str(x1)->f_len;
register Char * px1 = (Char *)(x1 + 1);
register Char * px2 = (Char *)x2;
while (li--) *(px2++) = *(px1++);
*(px2) = 0;
}
Char sel_rep_str (Rep_str x1,Nat1 x2)
{
if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
return *( ((Char *)(x1 + 1)) + x2 -1);
}

Rep_str copy_rep_str (Rep_str x1)
{Nat0 l1 = ref_rep_str(x1)->f_len;
Rep_str x2 = alloc_rep_str(l1);
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = *(px1++);
return x2;
}

Rep_str mkc_rep_str (Char * x1)
{register Nat0 li = 0;
register Char * lx1 = (Char *)x1;
while (*(lx1++)) li++;
{Rep_str x2 = alloc_rep_str(li);
register Char * lx2 = (Char *)(x2 + 1);
lx1 = (Char *)x1;
while (li--) *(lx2++) = *(lx1++);
return x2;
}
}
void del_rep_str (Rep_str x1)  {del1_rep_str(x1);}
Char hd_rep_str (Rep_str x1)  {return sel_rep_str(x1,(Nat1)1);}

static Nat0 _rr1_index_rep_str;
static Rep_str _tt1_index_rep_str; static Char _tt2_index_rep_str;

static void _ff1_index_rep_str(Char y1,Nat1 y2)

{if ((_rr1_index_rep_str == 0) && is_eq_char(y1,_tt2_index_rep_str)) _rr1_index_rep_str = y2;}

Nat0 index_rep_str(Rep_str x1,Char x2)

{Nat0 lr1; lr1 = _rr1_index_rep_str;
{Rep_str lt1; Char lt2; lt1 = _tt1_index_rep_str; lt2 = _tt2_index_rep_str;
{
{_tt1_index_rep_str = x1; _tt2_index_rep_str = x2;

{_rr1_index_rep_str = 0;
forindex_rep_str(x1,_ff1_index_rep_str);

_tt1_index_rep_str = lt1; _tt2_index_rep_str = lt2;
{Nat0 lr2; lr2 = _rr1_index_rep_str; _rr1_index_rep_str = lr1; return lr2;}
}}}}}

Nat0 len_rep_str (Rep_str x1)  {return (ref_rep_str(x1)->f_len);}

static Rep_str _tt1_forindex_rep_str; static T2_forindex_rep_str _tt2_forindex_rep_str; static Nat1 _ll1_forindex_rep_str;

static void _ff1_forindex_rep_str(Char y1)

{(*_tt2_forindex_rep_str)(y1,_ll1_forindex_rep_str++);}

void forindex_rep_str(Rep_str x1,T2_forindex_rep_str x2)

{
{Rep_str lt1; T2_forindex_rep_str lt2; lt1 = _tt1_forindex_rep_str; lt2 = _tt2_forindex_rep_str;
{Nat1 ll1; ll1 = _ll1_forindex_rep_str;
{_tt1_forindex_rep_str = x1; _tt2_forindex_rep_str = x2;
_ll1_forindex_rep_str = 1;
{
forall_rep_str(x1,_ff1_forindex_rep_str);

_tt1_forindex_rep_str = lt1; _tt2_forindex_rep_str = lt2; _ll1_forindex_rep_str = ll1;

}}}}}

Rep_population alloc_rep_population (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_population) + (x1 + 0) * sizeof(Chromosom);
Nat0 len2 = 4;
Rep_population lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_population) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_population");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_population))/sizeof(Chromosom));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_population (Rep_population x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_population) + x1->f_max*sizeof(Chromosom));
}

Rep_chromosom alloc_rep_chromosom (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_chromosom) + (x1 + 0) * sizeof(Real);
Nat0 len2 = 4;
Rep_chromosom lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_chromosom) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_chromosom");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_chromosom))/sizeof(Real));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_chromosom (Rep_chromosom x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_chromosom) + x1->f_max*sizeof(Real));
}

Rep_zeile alloc_rep_zeile (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_zeile) + (x1 + 0) * sizeof(Spalte);
Nat0 len2 = 4;
Rep_zeile lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_zeile) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_zeile");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_zeile))/sizeof(Spalte));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_zeile (Rep_zeile x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_zeile) + x1->f_max*sizeof(Spalte));
}

Rep_spalte alloc_rep_spalte (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_spalte) + (x1 + 0) * sizeof(Real);
Nat0 len2 = 4;
Rep_spalte lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_spalte) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_spalte");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_spalte))/sizeof(Real));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_spalte (Rep_spalte x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_spalte) + x1->f_max*sizeof(Real));
}

Rep_fitness alloc_rep_fitness (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_fitness) + (x1 + 0) * sizeof(Real);
Nat0 len2 = 4;
Rep_fitness lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_fitness) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_fitness");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_fitness))/sizeof(Real));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_fitness (Rep_fitness x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_fitness) + x1->f_max*sizeof(Real));
}

Iter_population mk_iter_population (Population x1)  {
Iter_population lx1;
check_handle_population(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_population(x1->f_rep);
return lx1;
}
Iter_chromosom mk_iter_chromosom (Chromosom x1)  {
Iter_chromosom lx1;
check_handle_chromosom(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_chromosom(x1->f_rep);
return lx1;
}
Iter_zeile mk_iter_zeile (Zeile x1)  {
Iter_zeile lx1;
check_handle_zeile(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_zeile(x1->f_rep);
return lx1;
}
Iter_spalte mk_iter_spalte (Spalte x1)  {
Iter_spalte lx1;
check_handle_spalte(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_spalte(x1->f_rep);
return lx1;
}
Iter_fitness mk_iter_fitness (Fitness x1)  {
Iter_fitness lx1;
check_handle_fitness(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_fitness(x1->f_rep);
return lx1;
}
void forall_cvtext_vdmlib (Cvtext_vdmlib x1,T2_forall_cvtext_vdmlib x2)
{Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;
Str * px1 = (Str * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}
Str sel_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2)
{
if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
return *( ((Str *)(x1 + 1)) + x2 -1);
}
Str last_cvtext_vdmlib (Cvtext_vdmlib x1)
{return sel_cvtext_vdmlib(x1,(Nat1)(len_cvtext_vdmlib(x1)));}
Cvtext_vdmlib mk_empty_cvtext_vdmlib (void)
{return alloc_cvtext_vdmlib((Nat0)0);}

Cvtext_vdmlib conc_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{Nat0 ll1 = ref_cvtext_vdmlib(x1)->f_len;
Nat0 ll = ll1 + ref_cvtext_vdmlib(x2)->f_len;
if (ll > x1->f_max)
{Cvtext_vdmlib lx3 = alloc_cvtext_vdmlib(ll);
register Nat0 i = ll1;
register Str * px3 = (Str *)(lx3 + 1);
register Str * px1 = (Str *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_cvtext_vdmlib(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Str * px1 = ((Str *)( x1 + 1)) + ll1;
register Str * px2 = (Str *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_cvtext_vdmlib(x2);
}
return x1;
}

Cvtext_vdmlib appr_cvtext_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Str *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_cvtext_vdmlib(x1,mk1_cvtext_vdmlib(x2)); }
}

Cvtext_vdmlib mk1_cvtext_vdmlib(Str x1)
{Cvtext_vdmlib lx1 = alloc_cvtext_vdmlib((Nat0)1);
*((Str *)(lx1+1)) = x1;
return lx1;
}

Cvtext_vdmlib ovwrt1_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2,Str x3)
{
if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
;
*( ((Str *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Str hd_cvtext_vdmlib (Cvtext_vdmlib x1)  {return sel_cvtext_vdmlib(x1,(Nat1)1);}

static Cvtext_vdmlib _tt1_del_cvtext_vdmlib;

static void _ff1_del_cvtext_vdmlib(Str y1)

{del_str(y1);}

void del_cvtext_vdmlib(Cvtext_vdmlib x1)

{
{Cvtext_vdmlib lt1; lt1 = _tt1_del_cvtext_vdmlib;
{
{_tt1_del_cvtext_vdmlib = x1;

{
forall_cvtext_vdmlib(x1,_ff1_del_cvtext_vdmlib);
del1_cvtext_vdmlib(x1);
_tt1_del_cvtext_vdmlib = lt1;

}}}}}

Bool is_empty_cvtext_vdmlib (Cvtext_vdmlib x1)
{return (ref_cvtext_vdmlib(x1)->f_len == 0);}

Nat0 len_cvtext_vdmlib (Cvtext_vdmlib x1)  {return (ref_cvtext_vdmlib(x1)->f_len);}
void del1_cvtext_vdmlib (Cvtext_vdmlib x1)  {free_cvtext_vdmlib(x1);}
void cond_clone_str (Str * x1)
{
if ((*x1)->f_rc > 1)
{
Str clone = alloc_str();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_str((*x1)->f_rep);
*x1 = clone;
}
}

Nat0 len_str (Str x1)
{
check_handle_str(x1);
return len_rep_str (x1->f_rep  ) ;
}

Nat0 index_str (Str x1,Char x2)
{
check_handle_str(x1);
return index_rep_str (x1->f_rep , x2 ) ;
}

Char hd_str (Str x1)
{
check_handle_str(x1);
return copy_char(hd_rep_str (x1->f_rep));
}

Str conc_auto_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
{
Rep_str lrep2 = copy_rep_str(x2->f_rep);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,lrep2);
}
return x1;
}

Str conc_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,x2->f_rep);
free_str(x2);
return x1;
}

Char sel_str (Str x1,Nat0 x2)
{
check_handle_str(x1);
return copy_char(sel_rep_str (x1->f_rep,x2));
}

void cpc_str (Str x1,char * x2)
{
check_handle_str(x1);
cpc_rep_str(x1->f_rep, x2);
}

Str mkc_str (char * x1)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mkc_rep_str(x1);
return l;
}
void del_str (Str x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_str(x1->f_rep);
free_str(x1);
}
}
Str copy_str (Str x1)
{
check_handle_str(x1);
x1->f_rc++;
return x1;
}

Str ovwrt1_str (Str x1,Nat1 x2,Char x3)
{
check_handle_str(x1);
cond_clone_str(&x1);
x3 = copy_char(x3);
x1->f_rep = ovwrt1d_rep_str (x1->f_rep,x2,x3) ;
return x1;
}
Str mkn_str (Char x1,Nat0 x2)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mknc_rep_str(x1,x2);
return l;
}

static Nat0 len_mfree_population = 0;

static Nat0 cnt_alloc_population = 0;
static Nat0 cnt_free_population = 0;
static Nat0 cnt_mallc_population = 0;
static Nat0 cnt_mfree_population = 0;

void profile_population (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Population");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_population);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_population);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_population);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_population);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_population);
fprintf(stderr,"\n");
}

static VOIDptr freelist_population = (VOIDptr)0;

Population alloc_population (void)
{Population x1;
cnt_alloc_population ++;
if (! freelist_population)
{while (! (x1 = (Population)ALLOCMEM_vdmlib(sizeof(struct Handle_population)))) heap_oflw_vdmlib("Heap_population");
cnt_mallc_population ++;
return x1;
}
freelist_population = *((VOIDptr *)(x1 = (Population) freelist_population));
len_mfree_population --;
return x1;
}

void free_population (Population x1)
{len_mfree_population ++;
cnt_free_population ++;
*((VOIDptr *)x1) = freelist_population;
freelist_population = (VOIDptr)x1;
if (len_mfree_population > 100)
{while (len_mfree_population > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_population);
FREEMEM_vdmlib(freelist_population,sizeof(struct Handle_population));
freelist_population = lx1;
len_mfree_population --;
cnt_mfree_population ++;
}
}
}

void forall_rep_population (Rep_population x1,T2_forall_rep_population x2)
{Nat0 lx1 = ref_rep_population(x1)->f_len;
Chromosom * px1 = (Chromosom * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_chromosom
extern Cvtext_vdmlib cvlines_chromosom ( Chromosom y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_population;
static void _rf1_cvlines1_rep_population(Chromosom y1 )

{_rr1_cvlines1_rep_population = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_population,cvlines_chromosom(y1 )  );}

Cvtext_vdmlib cvlines1_rep_population(Rep_population x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_population;
_rr1_cvlines1_rep_population = mk_empty_cvtext_vdmlib();
forall_rep_population(x1,_rf1_cvlines1_rep_population);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_population; _rr1_cvlines1_rep_population = lr1; return lr2;}
}

static Rep_population _tt1_forindex_rep_population; static T2_forindex_rep_population _tt2_forindex_rep_population; static Nat1 _ll1_forindex_rep_population;

static void _ff1_forindex_rep_population(Chromosom y1)

{(*_tt2_forindex_rep_population)(y1,_ll1_forindex_rep_population++);}

void forindex_rep_population(Rep_population x1,T2_forindex_rep_population x2)

{
{Rep_population lt1; T2_forindex_rep_population lt2; lt1 = _tt1_forindex_rep_population; lt2 = _tt2_forindex_rep_population;
{Nat1 ll1; ll1 = _ll1_forindex_rep_population;
{_tt1_forindex_rep_population = x1; _tt2_forindex_rep_population = x2;
_ll1_forindex_rep_population = 1;
{
forall_rep_population(x1,_ff1_forindex_rep_population);

_tt1_forindex_rep_population = lt1; _tt2_forindex_rep_population = lt2; _ll1_forindex_rep_population = ll1;

}}}}}

Rep_population mk1_rep_population(Chromosom x1)
{Rep_population lx1 = alloc_rep_population((Nat0)1);
*((Chromosom *)(lx1+1)) = x1;
return lx1;
}

static Rep_population _rr1_rmv1d_rep_population;
static Rep_population _tt1_rmv1d_rep_population; static Nat1 _tt2_rmv1d_rep_population;

static void _ff1_rmv1d_rep_population(Chromosom y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_rep_population) del_chromosom(y1); else _rr1_rmv1d_rep_population = appr_rep_population(_rr1_rmv1d_rep_population,y1);}

Rep_population rmv1d_rep_population(Rep_population x1,Nat1 x2)

{Rep_population lr1; lr1 = _rr1_rmv1d_rep_population;
{Rep_population lt1; Nat1 lt2; lt1 = _tt1_rmv1d_rep_population; lt2 = _tt2_rmv1d_rep_population;
{
{_tt1_rmv1d_rep_population = x1; _tt2_rmv1d_rep_population = x2;

{_rr1_rmv1d_rep_population = mk_empty_rep_population();
forindex_rep_population(x1,_ff1_rmv1d_rep_population);
del1_rep_population(x1);
_tt1_rmv1d_rep_population = lt1; _tt2_rmv1d_rep_population = lt2;
{Rep_population lr2; lr2 = _rr1_rmv1d_rep_population; _rr1_rmv1d_rep_population = lr1; return lr2;}
}}}}}

Rep_population copy_rep_population (Rep_population x1)
{Nat0 l1 = ref_rep_population(x1)->f_len;
Rep_population x2 = alloc_rep_population(l1);
register Chromosom * px1 = (Chromosom *)(x1+1);
register Chromosom * px2 = (Chromosom *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_chromosom(*(px1++));
return x2;
}

static Nat0 _rr1_index_rep_population;
static Rep_population _tt1_index_rep_population; static Chromosom _tt2_index_rep_population;

static void _ff1_index_rep_population(Chromosom y1,Nat1 y2)

{if ((_rr1_index_rep_population == 0) && is_eq_chromosom(y1,_tt2_index_rep_population)) _rr1_index_rep_population = y2;}

Nat0 index_rep_population(Rep_population x1,Chromosom x2)

{Nat0 lr1; lr1 = _rr1_index_rep_population;
{Rep_population lt1; Chromosom lt2; lt1 = _tt1_index_rep_population; lt2 = _tt2_index_rep_population;
{
{_tt1_index_rep_population = x1; _tt2_index_rep_population = x2;

{_rr1_index_rep_population = 0;
forindex_rep_population(x1,_ff1_index_rep_population);

_tt1_index_rep_population = lt1; _tt2_index_rep_population = lt2;
{Nat0 lr2; lr2 = _rr1_index_rep_population; _rr1_index_rep_population = lr1; return lr2;}
}}}}}

Cvtext_vdmlib cvlines_rep_population (Rep_population x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_population(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_population(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_population conc_rep_population (Rep_population x1,Rep_population x2)
{Nat0 ll1 = ref_rep_population(x1)->f_len;
Nat0 ll = ll1 + ref_rep_population(x2)->f_len;
if (ll > x1->f_max)
{Rep_population lx3 = alloc_rep_population(ll);
register Nat0 i = ll1;
register Chromosom * px3 = (Chromosom *)(lx3 + 1);
register Chromosom * px1 = (Chromosom *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_population(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Chromosom * px1 = ((Chromosom *)( x1 + 1)) + ll1;
register Chromosom * px2 = (Chromosom *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_population(x2);
}
return x1;
}

Rep_population tld_rep_population (Rep_population x1)
{
if (ref_rep_population(x1)->f_len == 0) { err_tl_vdmlib("Rep_population"); }
return sub_tupd_rep_population(x1,(Nat1)2,x1->f_len);
}

static Rep_population _tt1_del_rep_population;

static void _ff1_del_rep_population(Chromosom y1)

{del_chromosom(y1);}

void del_rep_population(Rep_population x1)

{
{Rep_population lt1; lt1 = _tt1_del_rep_population;
{
{_tt1_del_rep_population = x1;

{
forall_rep_population(x1,_ff1_del_rep_population);
del1_rep_population(x1);
_tt1_del_rep_population = lt1;

}}}}}

void del1_rep_population (Rep_population x1)  {free_rep_population(x1);}
Rep_population appr_rep_population (Rep_population x1,Chromosom x2)
{ Nat0 lx1 = ref_rep_population(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Chromosom *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_population(x1,mk1_rep_population(x2)); }
}

Rep_population sub_tupd_rep_population (Rep_population x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_population(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_chromosom( ((Chromosom *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_chromosom( ((Chromosom *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Chromosom * px1 = (Chromosom *)(x1+1);
/* start of array */
register Chromosom * px2 = px1 + (x2 - 1);
/* start of substring */
register Chromosom * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

static Nat0 len_mfree_chromosom = 0;

static Nat0 cnt_alloc_chromosom = 0;
static Nat0 cnt_free_chromosom = 0;
static Nat0 cnt_mallc_chromosom = 0;
static Nat0 cnt_mfree_chromosom = 0;

void profile_chromosom (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Chromosom");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_chromosom);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_chromosom);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_chromosom);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_chromosom);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_chromosom);
fprintf(stderr,"\n");
}

static VOIDptr freelist_chromosom = (VOIDptr)0;

Chromosom alloc_chromosom (void)
{Chromosom x1;
cnt_alloc_chromosom ++;
if (! freelist_chromosom)
{while (! (x1 = (Chromosom)ALLOCMEM_vdmlib(sizeof(struct Handle_chromosom)))) heap_oflw_vdmlib("Heap_chromosom");
cnt_mallc_chromosom ++;
return x1;
}
freelist_chromosom = *((VOIDptr *)(x1 = (Chromosom) freelist_chromosom));
len_mfree_chromosom --;
return x1;
}

void free_chromosom (Chromosom x1)
{len_mfree_chromosom ++;
cnt_free_chromosom ++;
*((VOIDptr *)x1) = freelist_chromosom;
freelist_chromosom = (VOIDptr)x1;
if (len_mfree_chromosom > 100)
{while (len_mfree_chromosom > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_chromosom);
FREEMEM_vdmlib(freelist_chromosom,sizeof(struct Handle_chromosom));
freelist_chromosom = lx1;
len_mfree_chromosom --;
cnt_mfree_chromosom ++;
}
}
}

void forall_rep_chromosom (Rep_chromosom x1,T2_forall_rep_chromosom x2)
{Nat0 lx1 = ref_rep_chromosom(x1)->f_len;
Real * px1 = (Real * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_chromosom;
static void _rf1_cvlines1_rep_chromosom(Real y1 )

{_rr1_cvlines1_rep_chromosom = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_chromosom,cvlines_real(y1 )  );}

Cvtext_vdmlib cvlines1_rep_chromosom(Rep_chromosom x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_chromosom;
_rr1_cvlines1_rep_chromosom = mk_empty_cvtext_vdmlib();
forall_rep_chromosom(x1,_rf1_cvlines1_rep_chromosom);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_chromosom; _rr1_cvlines1_rep_chromosom = lr1; return lr2;}
}

static Rep_chromosom _tt1_del_rep_chromosom;

static void _ff1_del_rep_chromosom(Real y1)

{del_real(y1);}

void del_rep_chromosom(Rep_chromosom x1)

{
{Rep_chromosom lt1; lt1 = _tt1_del_rep_chromosom;
{
{_tt1_del_rep_chromosom = x1;

{
forall_rep_chromosom(x1,_ff1_del_rep_chromosom);
del1_rep_chromosom(x1);
_tt1_del_rep_chromosom = lt1;

}}}}}

Rep_chromosom appr_rep_chromosom (Rep_chromosom x1,Real x2)
{ Nat0 lx1 = ref_rep_chromosom(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Real *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_chromosom(x1,mk1_rep_chromosom(x2)); }
}

Cvtext_vdmlib cvlines_rep_chromosom (Rep_chromosom x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_chromosom(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_chromosom(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_chromosom ovwrt1d_rep_chromosom (Rep_chromosom x1,Nat1 x2,Real x3)
{
if (x2 > ref_rep_chromosom(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_chromosom");
del_real(*( ((Real *)(x1 + 1)) + x2 -1));
*( ((Real *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_chromosom copy_rep_chromosom (Rep_chromosom x1)
{Nat0 l1 = ref_rep_chromosom(x1)->f_len;
Rep_chromosom x2 = alloc_rep_chromosom(l1);
register Real * px1 = (Real *)(x1+1);
register Real * px2 = (Real *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_real(*(px1++));
return x2;
}

Rep_chromosom sub_tupd_rep_chromosom (Rep_chromosom x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_chromosom(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_real( ((Real *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_real( ((Real *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Real * px1 = (Real *)(x1+1);
/* start of array */
register Real * px2 = px1 + (x2 - 1);
/* start of substring */
register Real * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

Rep_chromosom conc_rep_chromosom (Rep_chromosom x1,Rep_chromosom x2)
{Nat0 ll1 = ref_rep_chromosom(x1)->f_len;
Nat0 ll = ll1 + ref_rep_chromosom(x2)->f_len;
if (ll > x1->f_max)
{Rep_chromosom lx3 = alloc_rep_chromosom(ll);
register Nat0 i = ll1;
register Real * px3 = (Real *)(lx3 + 1);
register Real * px1 = (Real *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_chromosom(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Real * px1 = ((Real *)( x1 + 1)) + ll1;
register Real * px2 = (Real *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_chromosom(x2);
}
return x1;
}

Rep_chromosom tld_rep_chromosom (Rep_chromosom x1)
{
if (ref_rep_chromosom(x1)->f_len == 0) { err_tl_vdmlib("Rep_chromosom"); }
return sub_tupd_rep_chromosom(x1,(Nat1)2,x1->f_len);
}

Rep_chromosom mk1_rep_chromosom(Real x1)
{Rep_chromosom lx1 = alloc_rep_chromosom((Nat0)1);
*((Real *)(lx1+1)) = x1;
return lx1;
}

Bool is_eq_rep_chromosom (Rep_chromosom x1,Rep_chromosom x2)
{register Nat0 lx1 = ref_rep_chromosom(x1)->f_len;
if (lx1 != ref_rep_chromosom(x2)->f_len) return 0;
{Nat0 i = 0;
register Real * px1 = (Real *)(x1+1);
register Real * px2 = (Real *)(x2+1);
while (i != lx1)
{if (! is_eq_real(*(px1++),*(px2++))) return 0;
i++;
}
return 1;
}
}
void del1_rep_chromosom (Rep_chromosom x1)  {free_rep_chromosom(x1);}

static Nat0 len_mfree_zeile = 0;

static Nat0 cnt_alloc_zeile = 0;
static Nat0 cnt_free_zeile = 0;
static Nat0 cnt_mallc_zeile = 0;
static Nat0 cnt_mfree_zeile = 0;

void profile_zeile (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Zeile");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_zeile);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_zeile);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_zeile);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_zeile);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_zeile);
fprintf(stderr,"\n");
}

static VOIDptr freelist_zeile = (VOIDptr)0;

Zeile alloc_zeile (void)
{Zeile x1;
cnt_alloc_zeile ++;
if (! freelist_zeile)
{while (! (x1 = (Zeile)ALLOCMEM_vdmlib(sizeof(struct Handle_zeile)))) heap_oflw_vdmlib("Heap_zeile");
cnt_mallc_zeile ++;
return x1;
}
freelist_zeile = *((VOIDptr *)(x1 = (Zeile) freelist_zeile));
len_mfree_zeile --;
return x1;
}

void free_zeile (Zeile x1)
{len_mfree_zeile ++;
cnt_free_zeile ++;
*((VOIDptr *)x1) = freelist_zeile;
freelist_zeile = (VOIDptr)x1;
if (len_mfree_zeile > 100)
{while (len_mfree_zeile > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_zeile);
FREEMEM_vdmlib(freelist_zeile,sizeof(struct Handle_zeile));
freelist_zeile = lx1;
len_mfree_zeile --;
cnt_mfree_zeile ++;
}
}
}

void forall_rep_zeile (Rep_zeile x1,T2_forall_rep_zeile x2)
{Nat0 lx1 = ref_rep_zeile(x1)->f_len;
Spalte * px1 = (Spalte * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Rep_zeile sub_tupd_rep_zeile (Rep_zeile x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_zeile(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_spalte( ((Spalte *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_spalte( ((Spalte *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Spalte * px1 = (Spalte *)(x1+1);
/* start of array */
register Spalte * px2 = px1 + (x2 - 1);
/* start of substring */
register Spalte * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

static Rep_zeile _tt1_del_rep_zeile;

static void _ff1_del_rep_zeile(Spalte y1)

{del_spalte(y1);}

void del_rep_zeile(Rep_zeile x1)

{
{Rep_zeile lt1; lt1 = _tt1_del_rep_zeile;
{
{_tt1_del_rep_zeile = x1;

{
forall_rep_zeile(x1,_ff1_del_rep_zeile);
del1_rep_zeile(x1);
_tt1_del_rep_zeile = lt1;

}}}}}

Rep_zeile appr_rep_zeile (Rep_zeile x1,Spalte x2)
{ Nat0 lx1 = ref_rep_zeile(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Spalte *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_zeile(x1,mk1_rep_zeile(x2)); }
}

Cvtext_vdmlib cvlines_rep_zeile (Rep_zeile x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_zeile(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_zeile(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_zeile copy_rep_zeile (Rep_zeile x1)
{Nat0 l1 = ref_rep_zeile(x1)->f_len;
Rep_zeile x2 = alloc_rep_zeile(l1);
register Spalte * px1 = (Spalte *)(x1+1);
register Spalte * px2 = (Spalte *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_spalte(*(px1++));
return x2;
}

Rep_zeile conc_rep_zeile (Rep_zeile x1,Rep_zeile x2)
{Nat0 ll1 = ref_rep_zeile(x1)->f_len;
Nat0 ll = ll1 + ref_rep_zeile(x2)->f_len;
if (ll > x1->f_max)
{Rep_zeile lx3 = alloc_rep_zeile(ll);
register Nat0 i = ll1;
register Spalte * px3 = (Spalte *)(lx3 + 1);
register Spalte * px1 = (Spalte *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_zeile(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Spalte * px1 = ((Spalte *)( x1 + 1)) + ll1;
register Spalte * px2 = (Spalte *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_zeile(x2);
}
return x1;
}

Rep_zeile tld_rep_zeile (Rep_zeile x1)
{
if (ref_rep_zeile(x1)->f_len == 0) { err_tl_vdmlib("Rep_zeile"); }
return sub_tupd_rep_zeile(x1,(Nat1)2,x1->f_len);
}

Rep_zeile mk1_rep_zeile(Spalte x1)
{Rep_zeile lx1 = alloc_rep_zeile((Nat0)1);
*((Spalte *)(lx1+1)) = x1;
return lx1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_spalte
extern Cvtext_vdmlib cvlines_spalte ( Spalte y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_zeile;
static void _rf1_cvlines1_rep_zeile(Spalte y1 )

{_rr1_cvlines1_rep_zeile = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_zeile,cvlines_spalte(y1 )  );}

Cvtext_vdmlib cvlines1_rep_zeile(Rep_zeile x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_zeile;
_rr1_cvlines1_rep_zeile = mk_empty_cvtext_vdmlib();
forall_rep_zeile(x1,_rf1_cvlines1_rep_zeile);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_zeile; _rr1_cvlines1_rep_zeile = lr1; return lr2;}
}

void del1_rep_zeile (Rep_zeile x1)  {free_rep_zeile(x1);}

static Nat0 len_mfree_spalte = 0;

static Nat0 cnt_alloc_spalte = 0;
static Nat0 cnt_free_spalte = 0;
static Nat0 cnt_mallc_spalte = 0;
static Nat0 cnt_mfree_spalte = 0;

void profile_spalte (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Spalte");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_spalte);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_spalte);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_spalte);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_spalte);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_spalte);
fprintf(stderr,"\n");
}

static VOIDptr freelist_spalte = (VOIDptr)0;

Spalte alloc_spalte (void)
{Spalte x1;
cnt_alloc_spalte ++;
if (! freelist_spalte)
{while (! (x1 = (Spalte)ALLOCMEM_vdmlib(sizeof(struct Handle_spalte)))) heap_oflw_vdmlib("Heap_spalte");
cnt_mallc_spalte ++;
return x1;
}
freelist_spalte = *((VOIDptr *)(x1 = (Spalte) freelist_spalte));
len_mfree_spalte --;
return x1;
}

void free_spalte (Spalte x1)
{len_mfree_spalte ++;
cnt_free_spalte ++;
*((VOIDptr *)x1) = freelist_spalte;
freelist_spalte = (VOIDptr)x1;
if (len_mfree_spalte > 100)
{while (len_mfree_spalte > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_spalte);
FREEMEM_vdmlib(freelist_spalte,sizeof(struct Handle_spalte));
freelist_spalte = lx1;
len_mfree_spalte --;
cnt_mfree_spalte ++;
}
}
}

void forall_rep_spalte (Rep_spalte x1,T2_forall_rep_spalte x2)
{Nat0 lx1 = ref_rep_spalte(x1)->f_len;
Real * px1 = (Real * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Rep_spalte sub_tupd_rep_spalte (Rep_spalte x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_spalte(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_real( ((Real *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_real( ((Real *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Real * px1 = (Real *)(x1+1);
/* start of array */
register Real * px2 = px1 + (x2 - 1);
/* start of substring */
register Real * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

static Rep_spalte _tt1_del_rep_spalte;

static void _ff1_del_rep_spalte(Real y1)

{del_real(y1);}

void del_rep_spalte(Rep_spalte x1)

{
{Rep_spalte lt1; lt1 = _tt1_del_rep_spalte;
{
{_tt1_del_rep_spalte = x1;

{
forall_rep_spalte(x1,_ff1_del_rep_spalte);
del1_rep_spalte(x1);
_tt1_del_rep_spalte = lt1;

}}}}}

Rep_spalte appr_rep_spalte (Rep_spalte x1,Real x2)
{ Nat0 lx1 = ref_rep_spalte(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Real *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_spalte(x1,mk1_rep_spalte(x2)); }
}

Cvtext_vdmlib cvlines_rep_spalte (Rep_spalte x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_spalte(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_spalte(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_spalte copy_rep_spalte (Rep_spalte x1)
{Nat0 l1 = ref_rep_spalte(x1)->f_len;
Rep_spalte x2 = alloc_rep_spalte(l1);
register Real * px1 = (Real *)(x1+1);
register Real * px2 = (Real *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_real(*(px1++));
return x2;
}

Rep_spalte conc_rep_spalte (Rep_spalte x1,Rep_spalte x2)
{Nat0 ll1 = ref_rep_spalte(x1)->f_len;
Nat0 ll = ll1 + ref_rep_spalte(x2)->f_len;
if (ll > x1->f_max)
{Rep_spalte lx3 = alloc_rep_spalte(ll);
register Nat0 i = ll1;
register Real * px3 = (Real *)(lx3 + 1);
register Real * px1 = (Real *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_spalte(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Real * px1 = ((Real *)( x1 + 1)) + ll1;
register Real * px2 = (Real *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_spalte(x2);
}
return x1;
}

Rep_spalte tld_rep_spalte (Rep_spalte x1)
{
if (ref_rep_spalte(x1)->f_len == 0) { err_tl_vdmlib("Rep_spalte"); }
return sub_tupd_rep_spalte(x1,(Nat1)2,x1->f_len);
}

Rep_spalte mk1_rep_spalte(Real x1)
{Rep_spalte lx1 = alloc_rep_spalte((Nat0)1);
*((Real *)(lx1+1)) = x1;
return lx1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_spalte;
static void _rf1_cvlines1_rep_spalte(Real y1 )

{_rr1_cvlines1_rep_spalte = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_spalte,cvlines_real(y1 )  );}

Cvtext_vdmlib cvlines1_rep_spalte(Rep_spalte x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_spalte;
_rr1_cvlines1_rep_spalte = mk_empty_cvtext_vdmlib();
forall_rep_spalte(x1,_rf1_cvlines1_rep_spalte);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_spalte; _rr1_cvlines1_rep_spalte = lr1; return lr2;}
}

void del1_rep_spalte (Rep_spalte x1)  {free_rep_spalte(x1);}

static Nat0 len_mfree_fitness = 0;

static Nat0 cnt_alloc_fitness = 0;
static Nat0 cnt_free_fitness = 0;
static Nat0 cnt_mallc_fitness = 0;
static Nat0 cnt_mfree_fitness = 0;

void profile_fitness (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Fitness");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_fitness);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_fitness);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_fitness);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_fitness);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_fitness);
fprintf(stderr,"\n");
}

static VOIDptr freelist_fitness = (VOIDptr)0;

Fitness alloc_fitness (void)
{Fitness x1;
cnt_alloc_fitness ++;
if (! freelist_fitness)
{while (! (x1 = (Fitness)ALLOCMEM_vdmlib(sizeof(struct Handle_fitness)))) heap_oflw_vdmlib("Heap_fitness");
cnt_mallc_fitness ++;
return x1;
}
freelist_fitness = *((VOIDptr *)(x1 = (Fitness) freelist_fitness));
len_mfree_fitness --;
return x1;
}

void free_fitness (Fitness x1)
{len_mfree_fitness ++;
cnt_free_fitness ++;
*((VOIDptr *)x1) = freelist_fitness;
freelist_fitness = (VOIDptr)x1;
if (len_mfree_fitness > 100)
{while (len_mfree_fitness > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_fitness);
FREEMEM_vdmlib(freelist_fitness,sizeof(struct Handle_fitness));
freelist_fitness = lx1;
len_mfree_fitness --;
cnt_mfree_fitness ++;
}
}
}

void forall_rep_fitness (Rep_fitness x1,T2_forall_rep_fitness x2)
{Nat0 lx1 = ref_rep_fitness(x1)->f_len;
Real * px1 = (Real * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_fitness;
static void _rf1_cvlines1_rep_fitness(Real y1 )

{_rr1_cvlines1_rep_fitness = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_fitness,cvlines_real(y1 )  );}

Cvtext_vdmlib cvlines1_rep_fitness(Rep_fitness x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_fitness;
_rr1_cvlines1_rep_fitness = mk_empty_cvtext_vdmlib();
forall_rep_fitness(x1,_rf1_cvlines1_rep_fitness);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_fitness; _rr1_cvlines1_rep_fitness = lr1; return lr2;}
}

static Rep_fitness _tt1_forindex_rep_fitness; static T2_forindex_rep_fitness _tt2_forindex_rep_fitness; static Nat1 _ll1_forindex_rep_fitness;

static void _ff1_forindex_rep_fitness(Real y1)

{(*_tt2_forindex_rep_fitness)(y1,_ll1_forindex_rep_fitness++);}

void forindex_rep_fitness(Rep_fitness x1,T2_forindex_rep_fitness x2)

{
{Rep_fitness lt1; T2_forindex_rep_fitness lt2; lt1 = _tt1_forindex_rep_fitness; lt2 = _tt2_forindex_rep_fitness;
{Nat1 ll1; ll1 = _ll1_forindex_rep_fitness;
{_tt1_forindex_rep_fitness = x1; _tt2_forindex_rep_fitness = x2;
_ll1_forindex_rep_fitness = 1;
{
forall_rep_fitness(x1,_ff1_forindex_rep_fitness);

_tt1_forindex_rep_fitness = lt1; _tt2_forindex_rep_fitness = lt2; _ll1_forindex_rep_fitness = ll1;

}}}}}

Rep_fitness mk1_rep_fitness(Real x1)
{Rep_fitness lx1 = alloc_rep_fitness((Nat0)1);
*((Real *)(lx1+1)) = x1;
return lx1;
}

static Rep_fitness _rr1_rmv1d_rep_fitness;
static Rep_fitness _tt1_rmv1d_rep_fitness; static Nat1 _tt2_rmv1d_rep_fitness;

static void _ff1_rmv1d_rep_fitness(Real y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_rep_fitness) del_real(y1); else _rr1_rmv1d_rep_fitness = appr_rep_fitness(_rr1_rmv1d_rep_fitness,y1);}

Rep_fitness rmv1d_rep_fitness(Rep_fitness x1,Nat1 x2)

{Rep_fitness lr1; lr1 = _rr1_rmv1d_rep_fitness;
{Rep_fitness lt1; Nat1 lt2; lt1 = _tt1_rmv1d_rep_fitness; lt2 = _tt2_rmv1d_rep_fitness;
{
{_tt1_rmv1d_rep_fitness = x1; _tt2_rmv1d_rep_fitness = x2;

{_rr1_rmv1d_rep_fitness = mk_empty_rep_fitness();
forindex_rep_fitness(x1,_ff1_rmv1d_rep_fitness);
del1_rep_fitness(x1);
_tt1_rmv1d_rep_fitness = lt1; _tt2_rmv1d_rep_fitness = lt2;
{Rep_fitness lr2; lr2 = _rr1_rmv1d_rep_fitness; _rr1_rmv1d_rep_fitness = lr1; return lr2;}
}}}}}

Rep_fitness copy_rep_fitness (Rep_fitness x1)
{Nat0 l1 = ref_rep_fitness(x1)->f_len;
Rep_fitness x2 = alloc_rep_fitness(l1);
register Real * px1 = (Real *)(x1+1);
register Real * px2 = (Real *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_real(*(px1++));
return x2;
}

Cvtext_vdmlib cvlines_rep_fitness (Rep_fitness x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_fitness(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_fitness(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_fitness conc_rep_fitness (Rep_fitness x1,Rep_fitness x2)
{Nat0 ll1 = ref_rep_fitness(x1)->f_len;
Nat0 ll = ll1 + ref_rep_fitness(x2)->f_len;
if (ll > x1->f_max)
{Rep_fitness lx3 = alloc_rep_fitness(ll);
register Nat0 i = ll1;
register Real * px3 = (Real *)(lx3 + 1);
register Real * px1 = (Real *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_fitness(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Real * px1 = ((Real *)( x1 + 1)) + ll1;
register Real * px2 = (Real *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_fitness(x2);
}
return x1;
}

Rep_fitness tld_rep_fitness (Rep_fitness x1)
{
if (ref_rep_fitness(x1)->f_len == 0) { err_tl_vdmlib("Rep_fitness"); }
return sub_tupd_rep_fitness(x1,(Nat1)2,x1->f_len);
}

static Rep_fitness _tt1_del_rep_fitness;

static void _ff1_del_rep_fitness(Real y1)

{del_real(y1);}

void del_rep_fitness(Rep_fitness x1)

{
{Rep_fitness lt1; lt1 = _tt1_del_rep_fitness;
{
{_tt1_del_rep_fitness = x1;

{
forall_rep_fitness(x1,_ff1_del_rep_fitness);
del1_rep_fitness(x1);
_tt1_del_rep_fitness = lt1;

}}}}}

void del1_rep_fitness (Rep_fitness x1)  {free_rep_fitness(x1);}
Rep_fitness appr_rep_fitness (Rep_fitness x1,Real x2)
{ Nat0 lx1 = ref_rep_fitness(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Real *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_fitness(x1,mk1_rep_fitness(x2)); }
}

Rep_fitness sub_tupd_rep_fitness (Rep_fitness x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_fitness(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_real( ((Real *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_real( ((Real *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Real * px1 = (Real *)(x1+1);
/* start of array */
register Real * px2 = px1 + (x2 - 1);
/* start of substring */
register Real * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

void cond_clone_population (Population * x1)
{
if ((*x1)->f_rc > 1)
{
Population clone = alloc_population();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_population((*x1)->f_rep);
*x1 = clone;
}
}
void del_population (Population x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_population(x1->f_rep);
free_population(x1);
}
}

Nat0 len_population (Population x1)
{
check_handle_population(x1);
return len_rep_population (x1->f_rep  ) ;
}

Population appr_population (Population x1,Chromosom x2)
{
check_handle_population(x1);
cond_clone_population(&x1);
x2 = copy_chromosom(x2);
x1->f_rep = appr_rep_population (x1->f_rep,x2) ;
return x1;
}
Population appl_population (Chromosom x1,Population x2)
{
check_handle_population(x2);
cond_clone_population(&x2);
x1 = copy_chromosom(x1);
x2->f_rep = appl_rep_population(x1,x2->f_rep);
return x2;
}

Bool is_empty_population (Population x1)
{
check_handle_population(x1);
return is_empty_rep_population (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_population (Population x1)
{
check_handle_population(x1);
return cvlines_rep_population (x1->f_rep  ) ;
}

Nat0 index_population (Population x1,Chromosom x2)
{
check_handle_population(x1);
return index_rep_population (x1->f_rep , x2 ) ;
}

#ifdef __cplusplus
void fpr_population (ostream & x1,Population x2)
#else
void fpr_population (FILE * x1,Population x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_population(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Population rmv1_population (Population x1,Nat1 x2)
{
check_handle_population(x1);
cond_clone_population(&x1);
x1->f_rep = rmv1d_rep_population (x1->f_rep,x2) ;
return x1;
}

Population mk_empty_population (void)
{
Population l = alloc_population();
l->f_rc = 1;
l->f_rep = mk_empty_rep_population ();
return l;
}

Chromosom hd_population (Population x1)
{
check_handle_population(x1);
return copy_chromosom(hd_rep_population (x1->f_rep));
}

Population conc_population (Population x1,Population x2)
{
check_handle_population(x1);
check_handle_population(x2);
{
Rep_population lrep2 = copy_rep_population(x2->f_rep);
cond_clone_population(&x1);
x1->f_rep = conc_rep_population(x1->f_rep,lrep2);
}
return x1;
}

Population tl_population (Population x1)
{
check_handle_population(x1);
cond_clone_population(&x1);
x1->f_rep = tld_rep_population(x1->f_rep);
return x1;
}

Chromosom sel_population (Population x1,Nat0 x2)
{
check_handle_population(x1);
return copy_chromosom(sel_rep_population (x1->f_rep,x2));
}

Population mk1_population (Chromosom x1)
{
Population l = alloc_population();
l->f_rc = 1;
x1 = copy_chromosom(x1);
l->f_rep = mk1_rep_population (x1);
return l;
}
void cond_clone_chromosom (Chromosom * x1)
{
if ((*x1)->f_rc > 1)
{
Chromosom clone = alloc_chromosom();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_chromosom((*x1)->f_rep);
*x1 = clone;
}
}

Bool is_eq_chromosom (Chromosom x1,Chromosom x2)
{
check_handle_chromosom(x1);
check_handle_chromosom(x2);
return is_eq_rep_chromosom (x1->f_rep , x2->f_rep ) ;
}

void del_chromosom (Chromosom x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_chromosom(x1->f_rep);
free_chromosom(x1);
}
}

Nat0 len_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
return len_rep_chromosom (x1->f_rep  ) ;
}

Chromosom appr_chromosom (Chromosom x1,Real x2)
{
check_handle_chromosom(x1);
cond_clone_chromosom(&x1);
x2 = copy_real(x2);
x1->f_rep = appr_rep_chromosom (x1->f_rep,x2) ;
return x1;
}
Chromosom appl_chromosom (Real x1,Chromosom x2)
{
check_handle_chromosom(x2);
cond_clone_chromosom(&x2);
x1 = copy_real(x1);
x2->f_rep = appl_rep_chromosom(x1,x2->f_rep);
return x2;
}

Bool is_empty_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
return is_empty_rep_chromosom (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
return cvlines_rep_chromosom (x1->f_rep  ) ;
}

Chromosom ovwrt1_chromosom (Chromosom x1,Nat1 x2,Real x3)
{
check_handle_chromosom(x1);
cond_clone_chromosom(&x1);
x3 = copy_real(x3);
x1->f_rep = ovwrt1d_rep_chromosom (x1->f_rep,x2,x3) ;
return x1;
}

#ifdef __cplusplus
void fpr_chromosom (ostream & x1,Chromosom x2)
#else
void fpr_chromosom (FILE * x1,Chromosom x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_chromosom(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Chromosom sub_tup_chromosom (Chromosom x1,Nat1 x2,Nat0 x3)
{
check_handle_chromosom(x1);
cond_clone_chromosom(&x1);
x1->f_rep = sub_tupd_rep_chromosom (x1->f_rep,x2,x3) ;
return x1;
}

Chromosom mk_empty_chromosom (void)
{
Chromosom l = alloc_chromosom();
l->f_rc = 1;
l->f_rep = mk_empty_rep_chromosom ();
return l;
}

Real hd_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
return copy_real(hd_rep_chromosom (x1->f_rep));
}

Chromosom conc_chromosom (Chromosom x1,Chromosom x2)
{
check_handle_chromosom(x1);
check_handle_chromosom(x2);
{
Rep_chromosom lrep2 = copy_rep_chromosom(x2->f_rep);
cond_clone_chromosom(&x1);
x1->f_rep = conc_rep_chromosom(x1->f_rep,lrep2);
}
return x1;
}

Chromosom tl_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
cond_clone_chromosom(&x1);
x1->f_rep = tld_rep_chromosom(x1->f_rep);
return x1;
}

Real sel_chromosom (Chromosom x1,Nat0 x2)
{
check_handle_chromosom(x1);
return copy_real(sel_rep_chromosom (x1->f_rep,x2));
}

Chromosom mk1_chromosom (Real x1)
{
Chromosom l = alloc_chromosom();
l->f_rc = 1;
x1 = copy_real(x1);
l->f_rep = mk1_rep_chromosom (x1);
return l;
}
Chromosom copy_chromosom (Chromosom x1)
{
check_handle_chromosom(x1);
x1->f_rc++;
return x1;
}
void cond_clone_zeile (Zeile * x1)
{
if ((*x1)->f_rc > 1)
{
Zeile clone = alloc_zeile();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_zeile((*x1)->f_rep);
*x1 = clone;
}
}
void del_zeile (Zeile x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_zeile(x1->f_rep);
free_zeile(x1);
}
}

Nat0 len_zeile (Zeile x1)
{
check_handle_zeile(x1);
return len_rep_zeile (x1->f_rep  ) ;
}

Zeile appr_zeile (Zeile x1,Spalte x2)
{
check_handle_zeile(x1);
cond_clone_zeile(&x1);
x2 = copy_spalte(x2);
x1->f_rep = appr_rep_zeile (x1->f_rep,x2) ;
return x1;
}
Zeile appl_zeile (Spalte x1,Zeile x2)
{
check_handle_zeile(x2);
cond_clone_zeile(&x2);
x1 = copy_spalte(x1);
x2->f_rep = appl_rep_zeile(x1,x2->f_rep);
return x2;
}

Bool is_empty_zeile (Zeile x1)
{
check_handle_zeile(x1);
return is_empty_rep_zeile (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_zeile (Zeile x1)
{
check_handle_zeile(x1);
return cvlines_rep_zeile (x1->f_rep  ) ;
}

#ifdef __cplusplus
void fpr_zeile (ostream & x1,Zeile x2)
#else
void fpr_zeile (FILE * x1,Zeile x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_zeile(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Zeile mk_empty_zeile (void)
{
Zeile l = alloc_zeile();
l->f_rc = 1;
l->f_rep = mk_empty_rep_zeile ();
return l;
}

Spalte hd_zeile (Zeile x1)
{
check_handle_zeile(x1);
return copy_spalte(hd_rep_zeile (x1->f_rep));
}

Zeile conc_zeile (Zeile x1,Zeile x2)
{
check_handle_zeile(x1);
check_handle_zeile(x2);
{
Rep_zeile lrep2 = copy_rep_zeile(x2->f_rep);
cond_clone_zeile(&x1);
x1->f_rep = conc_rep_zeile(x1->f_rep,lrep2);
}
return x1;
}

Zeile tl_zeile (Zeile x1)
{
check_handle_zeile(x1);
cond_clone_zeile(&x1);
x1->f_rep = tld_rep_zeile(x1->f_rep);
return x1;
}

Spalte sel_zeile (Zeile x1,Nat0 x2)
{
check_handle_zeile(x1);
return copy_spalte(sel_rep_zeile (x1->f_rep,x2));
}

Zeile mk1_zeile (Spalte x1)
{
Zeile l = alloc_zeile();
l->f_rc = 1;
x1 = copy_spalte(x1);
l->f_rep = mk1_rep_zeile (x1);
return l;
}
void cond_clone_spalte (Spalte * x1)
{
if ((*x1)->f_rc > 1)
{
Spalte clone = alloc_spalte();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_spalte((*x1)->f_rep);
*x1 = clone;
}
}
Spalte copy_spalte (Spalte x1)
{
check_handle_spalte(x1);
x1->f_rc++;
return x1;
}

Spalte mk1_spalte (Real x1)
{
Spalte l = alloc_spalte();
l->f_rc = 1;
x1 = copy_real(x1);
l->f_rep = mk1_rep_spalte (x1);
return l;
}

Real sel_spalte (Spalte x1,Nat0 x2)
{
check_handle_spalte(x1);
return copy_real(sel_rep_spalte (x1->f_rep,x2));
}
Spalte tl_spalte (Spalte x1)
{
check_handle_spalte(x1);
cond_clone_spalte(&x1);
x1->f_rep = tld_rep_spalte(x1->f_rep);
return x1;
}

Spalte conc_spalte (Spalte x1,Spalte x2)
{
check_handle_spalte(x1);
check_handle_spalte(x2);
{
Rep_spalte lrep2 = copy_rep_spalte(x2->f_rep);
cond_clone_spalte(&x1);
x1->f_rep = conc_rep_spalte(x1->f_rep,lrep2);
}
return x1;
}

Real hd_spalte (Spalte x1)
{
check_handle_spalte(x1);
return copy_real(hd_rep_spalte (x1->f_rep));
}

Spalte mk_empty_spalte (void)
{
Spalte l = alloc_spalte();
l->f_rc = 1;
l->f_rep = mk_empty_rep_spalte ();
return l;
}

#ifdef __cplusplus
void fpr_spalte (ostream & x1,Spalte x2)
#else
void fpr_spalte (FILE * x1,Spalte x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_spalte(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Cvtext_vdmlib cvlines_spalte (Spalte x1)
{
check_handle_spalte(x1);
return cvlines_rep_spalte (x1->f_rep  ) ;
}

Bool is_empty_spalte (Spalte x1)
{
check_handle_spalte(x1);
return is_empty_rep_spalte (x1->f_rep  ) ;
}

Spalte appl_spalte (Real x1,Spalte x2)
{
check_handle_spalte(x2);
cond_clone_spalte(&x2);
x1 = copy_real(x1);
x2->f_rep = appl_rep_spalte(x1,x2->f_rep);
return x2;
}

Spalte appr_spalte (Spalte x1,Real x2)
{
check_handle_spalte(x1);
cond_clone_spalte(&x1);
x2 = copy_real(x2);
x1->f_rep = appr_rep_spalte (x1->f_rep,x2) ;
return x1;
}

Nat0 len_spalte (Spalte x1)
{
check_handle_spalte(x1);
return len_rep_spalte (x1->f_rep  ) ;
}

void del_spalte (Spalte x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_spalte(x1->f_rep);
free_spalte(x1);
}
}
void cond_clone_fitness (Fitness * x1)
{
if ((*x1)->f_rc > 1)
{
Fitness clone = alloc_fitness();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_fitness((*x1)->f_rep);
*x1 = clone;
}
}
void del_fitness (Fitness x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_fitness(x1->f_rep);
free_fitness(x1);
}
}

Nat0 len_fitness (Fitness x1)
{
check_handle_fitness(x1);
return len_rep_fitness (x1->f_rep  ) ;
}

Fitness appr_fitness (Fitness x1,Real x2)
{
check_handle_fitness(x1);
cond_clone_fitness(&x1);
x2 = copy_real(x2);
x1->f_rep = appr_rep_fitness (x1->f_rep,x2) ;
return x1;
}
Fitness appl_fitness (Real x1,Fitness x2)
{
check_handle_fitness(x2);
cond_clone_fitness(&x2);
x1 = copy_real(x1);
x2->f_rep = appl_rep_fitness(x1,x2->f_rep);
return x2;
}

Bool is_empty_fitness (Fitness x1)
{
check_handle_fitness(x1);
return is_empty_rep_fitness (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_fitness (Fitness x1)
{
check_handle_fitness(x1);
return cvlines_rep_fitness (x1->f_rep  ) ;
}

#ifdef __cplusplus
void fpr_fitness (ostream & x1,Fitness x2)
#else
void fpr_fitness (FILE * x1,Fitness x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_fitness(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Fitness rmv1_fitness (Fitness x1,Nat1 x2)
{
check_handle_fitness(x1);
cond_clone_fitness(&x1);
x1->f_rep = rmv1d_rep_fitness (x1->f_rep,x2) ;
return x1;
}

Fitness mk_empty_fitness (void)
{
Fitness l = alloc_fitness();
l->f_rc = 1;
l->f_rep = mk_empty_rep_fitness ();
return l;
}

Real hd_fitness (Fitness x1)
{
check_handle_fitness(x1);
return copy_real(hd_rep_fitness (x1->f_rep));
}

Fitness conc_fitness (Fitness x1,Fitness x2)
{
check_handle_fitness(x1);
check_handle_fitness(x2);
{
Rep_fitness lrep2 = copy_rep_fitness(x2->f_rep);
cond_clone_fitness(&x1);
x1->f_rep = conc_rep_fitness(x1->f_rep,lrep2);
}
return x1;
}

Fitness tl_fitness (Fitness x1)
{
check_handle_fitness(x1);
cond_clone_fitness(&x1);
x1->f_rep = tld_rep_fitness(x1->f_rep);
return x1;
}

Real sel_fitness (Fitness x1,Nat0 x2)
{
check_handle_fitness(x1);
return copy_real(sel_rep_fitness (x1->f_rep,x2));
}

Fitness mk1_fitness (Real x1)
{
Fitness l = alloc_fitness();
l->f_rc = 1;
x1 = copy_real(x1);
l->f_rep = mk1_rep_fitness (x1);
return l;
}
