#ifndef VDM_header_tsp
#define VDM_header_tsp


/* ------- PHASE1 ------------------ */
/*
module generated from VDM Class Library
$Revision: 1.1 $
$Date: 1996/07/04 07:44:15 $
*/

#if defined(sun) && ! defined(sparc)
#define __BSD42__
#endif

#ifdef M_XENIX
#define __XENIX__
#define __SYSV__
#endif

#ifdef __TURBOC__
#define __DOS__
#endif

#if defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
typedef void * VOIDptr;
#else
typedef char * VOIDptr;
#endif

#if defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
#ifndef __POSIX
#define __POSIX
#endif
#endif

#ifdef __cplusplus
#include <stdlib.h>
#else
#if defined(__STDC__) || defined(__POSIX)
#ifndef apollo
#include <stdlib.h>
#endif
#endif
#endif

#ifdef __cplusplus
#include <stdio.h>
#endif

#ifdef __cplusplus
#include <iostream.h>
#else
#include <stdio.h>
#endif

#include <stdio.h>

#include <float.h>

#ifdef __BSD42__
#include <strings.h>
#else
#include <string.h>
#endif

/* some systems define TRUE and FALSE in system header files */
#ifndef FALSE
#ifndef TRUE

/* Bool as enum requires conversion between enum and int */
#ifdef BoolAsEnum
enum {FALSE,TRUE};
#else
#define FALSE ((unsigned char)0)
#define TRUE ((unsigned char)1)
#endif

#ifdef __cplusplus
#define false BOOL(FALSE)
#define true BOOL(TRUE)
#endif

#endif
#endif

typedef unsigned char Bool;

typedef double Real;

#define lb_nat1 1

#define ub_nat1 2147483647

typedef unsigned long Nat1;

#define lb_nat0 0

#define ub_nat0 2147483647

typedef unsigned long Nat0;

#define lb_intg -2147483647

#define ub_intg 2147483647

typedef long int Intg;

typedef char Char;
#define lb_char 0

#define ub_char 255

typedef struct Struct_rep_str * Rep_str;
typedef struct Struct_cvtext_vdmlib * Cvtext_vdmlib;
typedef struct Handle_str * Str;
typedef struct Struct_rep_population * Rep_population;
typedef struct Struct_rep_chromosom * Rep_chromosom;
typedef struct Struct_rep_zeile * Rep_zeile;
typedef struct Struct_rep_spalte * Rep_spalte;
typedef struct Struct_rep_fitness * Rep_fitness;
typedef struct Handle_population * Population;
typedef struct Handle_chromosom * Chromosom;
typedef struct Handle_zeile * Zeile;
typedef struct Handle_spalte * Spalte;
typedef struct Handle_fitness * Fitness;

/* ------- PHASE2 ------------------ */
#define VDM_ERR_EMPTYSET 1
#define VDM_ERR_EMPTYMAP 2
#define VDM_ERR_EMPTYHD 3
#define VDM_ERR_ERRMAXLEN 4
#define VDM_ERR_NILPTR 5
#define VDM_ERR_NILOPT 6
#define VDM_ERR_ILLPTR 7
#define VDM_ERR_SELECT 8
#define VDM_ERR_SELMAP 9
#define VDM_ERR_UNIO 10
#define VDM_ERR_EMPTYTL 11
#define VDM_ERR_UNION 12
#define VDM_ERR_NOTIMPL 13
#define VDM_ERR_HEAPOFL 15
#define VDM_ERR_CVLINES 16
#define VDM_ERR_NV_HDL 17
#define VDM_ERR_EMPTYIT 18
#define VDM_ERR_DIV0 19

extern Bool supress_cvlines_vdmlib;
extern Nat0 curr_linelen_vdmlib;
extern char *start_structure_vdmlib;
extern char *end_structure_vdmlib;

extern void adj_linelen_vdmlib ( Nat0 x1 ) ;
extern Str ident_prefix_vdmlib ( Str x1, Nat0 x2 ) ;
extern Cvtext_vdmlib ident_lines_vdmlib ( Cvtext_vdmlib x1, Str x2 ) ;
extern Cvtext_vdmlib close_struct_vdmlib ( Cvtext_vdmlib x1,Str x2, Nat0 x3 ) ;
extern Cvtext_vdmlib append_lastline_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
#ifdef __cplusplus
extern void fprint_lines_vdmlib ( ostream & x1,Cvtext_vdmlib x2 ) ;
#else
extern void fprint_lines_vdmlib ( FILE *x1,Cvtext_vdmlib x2 ) ;
#endif

#ifdef __cplusplus
inline VOIDptr ALLOCMEM_vdmlib(unsigned long int x1)
{ return (VOIDptr)(new char[x1]); }
inline void FREEMEM_vdmlib(VOIDptr x1,unsigned long int)
{ delete (char *)(x1); }
#else
#if ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
extern VOIDptr malloc ( unsigned long x1 ) ;
extern void free ( VOIDptr x1 ) ;
#endif
#define ALLOCMEM_vdmlib(x1) malloc(x1)
#define FREEMEM_vdmlib(x1,x2) free(x1)
#endif

struct Struct_iter_rep_population {
Rep_population f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_population Iter_rep_population;
struct Struct_iter_rep_chromosom {
Rep_chromosom f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_chromosom Iter_rep_chromosom;
struct Struct_iter_rep_zeile {
Rep_zeile f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_zeile Iter_rep_zeile;
struct Struct_iter_rep_spalte {
Rep_spalte f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_spalte Iter_rep_spalte;
struct Struct_iter_rep_fitness {
Rep_fitness f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_fitness Iter_rep_fitness;
struct Struct_rep_str {
Nat0 f_max;
Nat0 f_len;
};

struct Struct_iter_population {
Iter_rep_population f_ir;
Population f_vl;
};

typedef struct Struct_iter_population Iter_population;
struct Struct_iter_chromosom {
Iter_rep_chromosom f_ir;
Chromosom f_vl;
};

typedef struct Struct_iter_chromosom Iter_chromosom;
struct Struct_iter_zeile {
Iter_rep_zeile f_ir;
Zeile f_vl;
};

typedef struct Struct_iter_zeile Iter_zeile;
struct Struct_iter_spalte {
Iter_rep_spalte f_ir;
Spalte f_vl;
};

typedef struct Struct_iter_spalte Iter_spalte;
struct Struct_iter_fitness {
Iter_rep_fitness f_ir;
Fitness f_vl;
};

typedef struct Struct_iter_fitness Iter_fitness;
struct Struct_cvtext_vdmlib {
Nat0 f_max;
Nat0 f_len;
};

struct Handle_str {
Rep_str f_rep;
Nat0 f_rc;
};

#define AUTOMEM_str

void cond_clone_str ( Str * ) ;

#define check_handle_str(h) if ((h) == 0) err_nv_hdl_vdmlib("Str");
struct Struct_rep_population {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_population(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_rep_chromosom {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_chromosom(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_rep_zeile {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_zeile(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_rep_spalte {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_spalte(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_rep_fitness {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_fitness(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_population {
Rep_population f_rep;
Nat0 f_rc;
};

#define AUTOMEM_population

void cond_clone_population ( Population * ) ;

#define check_handle_population(h) if ((h) == 0) err_nv_hdl_vdmlib("Population");

struct Handle_chromosom {
Rep_chromosom f_rep;
Nat0 f_rc;
};

#define AUTOMEM_chromosom

void cond_clone_chromosom ( Chromosom * ) ;

#define check_handle_chromosom(h) if ((h) == 0) err_nv_hdl_vdmlib("Chromosom");

struct Handle_zeile {
Rep_zeile f_rep;
Nat0 f_rc;
};

#define AUTOMEM_zeile

void cond_clone_zeile ( Zeile * ) ;

#define check_handle_zeile(h) if ((h) == 0) err_nv_hdl_vdmlib("Zeile");

struct Handle_spalte {
Rep_spalte f_rep;
Nat0 f_rc;
};

#define AUTOMEM_spalte

void cond_clone_spalte ( Spalte * ) ;

#define check_handle_spalte(h) if ((h) == 0) err_nv_hdl_vdmlib("Spalte");

struct Handle_fitness {
Rep_fitness f_rep;
Nat0 f_rc;
};

#define AUTOMEM_fitness

void cond_clone_fitness ( Fitness * ) ;

#define check_handle_fitness(h) if ((h) == 0) err_nv_hdl_vdmlib("Fitness");

/* ------- PHASE3 ------------------ */
extern void err_empty_iterator_vdmlib ( char *x1 );
extern void abort_vdmlib ( Nat0 x1 );
extern void heap_oflw_vdmlib ( char *x1 );
extern void err_nv_hdl_vdmlib ( char *x1 );
extern void err_sel_vdmlib ( Nat1 x1 , Nat0 x2 , char *x3 );
extern void err_tl_vdmlib ( char *x1 );
extern Bool and_bool ( Bool x1 , Bool x2 );
extern Bool is_eq_bool ( Bool x1 , Bool x2 );
extern Bool is_ge_bool ( Bool x1 , Bool x2 );
extern Bool or_bool ( Bool x1 , Bool x2 );
extern Bool not_bool ( Bool x1 );
extern Bool is_gr_bool ( Bool x1 , Bool x2 );
extern Bool xor_bool ( Bool x1 , Bool x2 );
extern void del_real ( Real x1 );
extern Real copy_real ( Real x1 );
extern Real pred_real ( Real x1 );
extern Bool is_eq_real ( Real x1 , Real x2 );
extern Bool is_lt_real ( Real x1 , Real x2 );
extern Bool is_ge_real ( Real x1 , Real x2 );
extern Real times_real ( Real x1 , Real x2 );
extern Real plus_real ( Real x1 , Real x2 );
#ifdef __cplusplus
extern void fpr_real ( ostream & x1 , Real x2 );
#else
extern void fpr_real ( FILE *x1 , Real x2 );
#endif
extern Cvtext_vdmlib cvlines_real ( Real x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Real succ_real ( Real x1 );
extern Bool is_le_real ( Real x1 , Real x2 );
extern Bool is_gr_real ( Real x1 , Real x2 );
extern Real div_real ( Real x1 , Real x2 );
extern Real minus_real ( Real x1 , Real x2 );
extern char * printformat_real;

extern void set_print_format_real ( char * x1 );
extern Nat1 minus_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 div_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_gr_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_le_nat1 ( Nat1 x1 , Nat1 x2 );

extern Nat1 mod_nat1 ( Nat1 x1 , Nat1 x2 );

extern Nat1 succ_nat1 ( Nat1 x1 );
extern Nat1 plus_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 times_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_ge_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_lt_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_eq_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 pred_nat1 ( Nat1 x1 );
extern Nat0 minus_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 div_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_gr_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_le_nat0 ( Nat0 x1 , Nat0 x2 );

extern Nat0 mod_nat0 ( Nat0 x1 , Nat0 x2 );

extern Nat0 succ_nat0 ( Nat0 x1 );
extern Nat0 plus_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 times_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_ge_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_lt_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_eq_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 pred_nat0 ( Nat0 x1 );
extern Intg minus_intg ( Intg x1 , Intg x2 );
extern Intg div_intg ( Intg x1 , Intg x2 );
extern Bool is_gr_intg ( Intg x1 , Intg x2 );
extern Bool is_le_intg ( Intg x1 , Intg x2 );

extern Intg mod_intg ( Intg x1 , Intg x2 );

extern Intg succ_intg ( Intg x1 );
extern Intg plus_intg ( Intg x1 , Intg x2 );
extern Intg times_intg ( Intg x1 , Intg x2 );
extern Bool is_ge_intg ( Intg x1 , Intg x2 );
extern Bool is_lt_intg ( Intg x1 , Intg x2 );
extern Bool is_eq_intg ( Intg x1 , Intg x2 );
extern Intg pred_intg ( Intg x1 );
extern void del_char ( Char x1 );
extern Char minus_char ( Char x1 , Char x2 );
extern Char div_char ( Char x1 , Char x2 );
extern Bool is_gr_char ( Char x1 , Char x2 );
extern Bool is_le_char ( Char x1 , Char x2 );

extern Char mod_char ( Char x1 , Char x2 );

extern Char succ_char ( Char x1 );
extern Char plus_char ( Char x1 , Char x2 );
extern Char times_char ( Char x1 , Char x2 );
extern Bool is_ge_char ( Char x1 , Char x2 );
extern Bool is_lt_char ( Char x1 , Char x2 );
extern Bool is_eq_char ( Char x1 , Char x2 );
extern Char pred_char ( Char x1 );
extern Char copy_char ( Char x1 );
extern Cvtext_vdmlib alloc_cvtext_vdmlib ( Nat0 x1 );
extern void free_cvtext_vdmlib ( Cvtext_vdmlib x1 );

#define ref_cvtext_vdmlib(x1) (x1)

#define profile_cvtext_vdmlib()

extern Rep_str alloc_rep_str ( Nat0 x1 );
extern void free_rep_str ( Rep_str x1 );

#define ref_rep_str(x1) (x1)

#define profile_rep_str()

#define FOR_iter_rep_population(x1,x2) { Iter_rep_population x2##_it = mk_iter_rep_population(x1); while (!is_empty_iter_rep_population(& x2##_it)) { Chromosom x2 = sel_iter_rep_population(& x2##_it);
#define ENDFOR_iter_rep_population(x2) next_iter_rep_population(& x2##_it); } del_iter_rep_population(x2##_it); }

extern Iter_rep_population mk_iter_rep_population ( Rep_population x1 );
extern void next_iter_rep_population ( Iter_rep_population * x1 );
extern Chromosom sel_iter_rep_population ( Iter_rep_population * x1 );

#define FOR_iter_rep_chromosom(x1,x2) { Iter_rep_chromosom x2##_it = mk_iter_rep_chromosom(x1); while (!is_empty_iter_rep_chromosom(& x2##_it)) { Real x2 = sel_iter_rep_chromosom(& x2##_it);
#define ENDFOR_iter_rep_chromosom(x2) next_iter_rep_chromosom(& x2##_it); } del_iter_rep_chromosom(x2##_it); }

extern Iter_rep_chromosom mk_iter_rep_chromosom ( Rep_chromosom x1 );
extern void next_iter_rep_chromosom ( Iter_rep_chromosom * x1 );
extern Real sel_iter_rep_chromosom ( Iter_rep_chromosom * x1 );

#define FOR_iter_rep_zeile(x1,x2) { Iter_rep_zeile x2##_it = mk_iter_rep_zeile(x1); while (!is_empty_iter_rep_zeile(& x2##_it)) { Spalte x2 = sel_iter_rep_zeile(& x2##_it);
#define ENDFOR_iter_rep_zeile(x2) next_iter_rep_zeile(& x2##_it); } del_iter_rep_zeile(x2##_it); }

extern Iter_rep_zeile mk_iter_rep_zeile ( Rep_zeile x1 );
extern void next_iter_rep_zeile ( Iter_rep_zeile * x1 );
extern Spalte sel_iter_rep_zeile ( Iter_rep_zeile * x1 );

#define FOR_iter_rep_spalte(x1,x2) { Iter_rep_spalte x2##_it = mk_iter_rep_spalte(x1); while (!is_empty_iter_rep_spalte(& x2##_it)) { Real x2 = sel_iter_rep_spalte(& x2##_it);
#define ENDFOR_iter_rep_spalte(x2) next_iter_rep_spalte(& x2##_it); } del_iter_rep_spalte(x2##_it); }

extern Iter_rep_spalte mk_iter_rep_spalte ( Rep_spalte x1 );
extern void next_iter_rep_spalte ( Iter_rep_spalte * x1 );
extern Real sel_iter_rep_spalte ( Iter_rep_spalte * x1 );

#define FOR_iter_rep_fitness(x1,x2) { Iter_rep_fitness x2##_it = mk_iter_rep_fitness(x1); while (!is_empty_iter_rep_fitness(& x2##_it)) { Real x2 = sel_iter_rep_fitness(& x2##_it);
#define ENDFOR_iter_rep_fitness(x2) next_iter_rep_fitness(& x2##_it); } del_iter_rep_fitness(x2##_it); }

extern Iter_rep_fitness mk_iter_rep_fitness ( Rep_fitness x1 );
extern void next_iter_rep_fitness ( Iter_rep_fitness * x1 );
extern Real sel_iter_rep_fitness ( Iter_rep_fitness * x1 );
extern Str alloc_str ( void );
extern void free_str ( Str x1 );

#define ref_str(x1) (x1)

extern void profile_str ( void );

typedef void (* T2_forall_rep_str) ( Char y1 ) ;
extern void forall_rep_str ( Rep_str x1, T2_forall_rep_str x2 ) ;
extern void del1_rep_str ( Rep_str x1 );
extern Rep_str mknc_rep_str ( Char x1 , Nat0 x2 );
extern Rep_str ovwrt1d_rep_str ( Rep_str x1 , Nat1 x2 , Char x3 );
extern Rep_str conc_rep_str ( Rep_str x1 , Rep_str x2 );
extern void cpc_rep_str ( Rep_str x1 , Char *x2 );
extern Char sel_rep_str ( Rep_str x1 , Nat1 x2 );
extern Rep_str copy_rep_str ( Rep_str x1 );
extern Rep_str mkc_rep_str ( Char *x1 );
extern void del_rep_str ( Rep_str x1 );
extern Char hd_rep_str ( Rep_str x1 );
extern Nat0 index_rep_str ( Rep_str x1 , Char x2 );
extern Nat0 len_rep_str ( Rep_str x1 );
typedef void (* T2_forindex_rep_str) ( Char y1, Nat1 y2 ) ;
extern void forindex_rep_str ( Rep_str x1, T2_forindex_rep_str x2 ) ;
extern Rep_population alloc_rep_population ( Nat0 x1 );
extern void free_rep_population ( Rep_population x1 );

#define ref_rep_population(x1) (x1)

#define profile_rep_population()

extern Rep_chromosom alloc_rep_chromosom ( Nat0 x1 );
extern void free_rep_chromosom ( Rep_chromosom x1 );

#define ref_rep_chromosom(x1) (x1)

#define profile_rep_chromosom()

extern Rep_zeile alloc_rep_zeile ( Nat0 x1 );
extern void free_rep_zeile ( Rep_zeile x1 );

#define ref_rep_zeile(x1) (x1)

#define profile_rep_zeile()

extern Rep_spalte alloc_rep_spalte ( Nat0 x1 );
extern void free_rep_spalte ( Rep_spalte x1 );

#define ref_rep_spalte(x1) (x1)

#define profile_rep_spalte()

extern Rep_fitness alloc_rep_fitness ( Nat0 x1 );
extern void free_rep_fitness ( Rep_fitness x1 );

#define ref_rep_fitness(x1) (x1)

#define profile_rep_fitness()

#define FOR_iter_population(x1,x2) { Iter_population x2##_it = mk_iter_population(x1); while (!is_empty_iter_population(& x2##_it)) { Chromosom x2 = sel_iter_population(& x2##_it);
#define ENDFOR_iter_population(x2) next_iter_population(& x2##_it); } del_iter_population(x2##_it); }

extern Iter_population mk_iter_population ( Population x1 );

#define FOR_iter_chromosom(x1,x2) { Iter_chromosom x2##_it = mk_iter_chromosom(x1); while (!is_empty_iter_chromosom(& x2##_it)) { Real x2 = sel_iter_chromosom(& x2##_it);
#define ENDFOR_iter_chromosom(x2) next_iter_chromosom(& x2##_it); } del_iter_chromosom(x2##_it); }

extern Iter_chromosom mk_iter_chromosom ( Chromosom x1 );

#define FOR_iter_zeile(x1,x2) { Iter_zeile x2##_it = mk_iter_zeile(x1); while (!is_empty_iter_zeile(& x2##_it)) { Spalte x2 = sel_iter_zeile(& x2##_it);
#define ENDFOR_iter_zeile(x2) next_iter_zeile(& x2##_it); } del_iter_zeile(x2##_it); }

extern Iter_zeile mk_iter_zeile ( Zeile x1 );

#define FOR_iter_spalte(x1,x2) { Iter_spalte x2##_it = mk_iter_spalte(x1); while (!is_empty_iter_spalte(& x2##_it)) { Real x2 = sel_iter_spalte(& x2##_it);
#define ENDFOR_iter_spalte(x2) next_iter_spalte(& x2##_it); } del_iter_spalte(x2##_it); }

extern Iter_spalte mk_iter_spalte ( Spalte x1 );

#define FOR_iter_fitness(x1,x2) { Iter_fitness x2##_it = mk_iter_fitness(x1); while (!is_empty_iter_fitness(& x2##_it)) { Real x2 = sel_iter_fitness(& x2##_it);
#define ENDFOR_iter_fitness(x2) next_iter_fitness(& x2##_it); } del_iter_fitness(x2##_it); }

extern Iter_fitness mk_iter_fitness ( Fitness x1 );
typedef void (* T2_forall_cvtext_vdmlib) ( Str y1 ) ;
extern void forall_cvtext_vdmlib ( Cvtext_vdmlib x1, T2_forall_cvtext_vdmlib x2 ) ;
extern Str sel_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 );
extern Str last_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void );
extern Cvtext_vdmlib conc_cvtext_vdmlib ( Cvtext_vdmlib x1 , Cvtext_vdmlib x2 );
extern Cvtext_vdmlib appr_cvtext_vdmlib ( Cvtext_vdmlib x1 , Str x2 );
extern Cvtext_vdmlib mk1_cvtext_vdmlib ( Str x1 );
extern Cvtext_vdmlib ovwrt1_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 , Str x3 );
extern Str hd_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Bool is_empty_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Nat0 len_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del1_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Nat0 len_str ( Str x1 );
extern Nat0 index_str ( Str x1 , Char x2 );
extern Char hd_str ( Str x1 );
extern Str conc_str ( Str x1 , Str x2 );
extern Str conc_auto_str ( Str x1 , Str x2 );
extern Char sel_str ( Str x1 , Nat1 x2 );
extern void cpc_str ( Str x1 , Char *x2 );
extern Str mkc_str ( Char *x1 );
extern void del_str ( Str x1 );
extern Str copy_str ( Str x1 );
extern Str ovwrt1_str ( Str x1 , Nat1 x2 , Char x3 );
extern Str mkn_str ( Char x1 , Nat0 x2 );
extern Population alloc_population ( void );
extern void free_population ( Population x1 );

#define ref_population(x1) (x1)

extern void profile_population ( void );

typedef void (* T2_forall_rep_population) ( Chromosom y1 ) ;
extern void forall_rep_population ( Rep_population x1, T2_forall_rep_population x2 ) ;

extern Cvtext_vdmlib cvlines1_rep_population ( Rep_population x1 );

typedef void (* T2_forindex_rep_population) ( Chromosom y1, Nat1 y2 ) ;
extern void forindex_rep_population ( Rep_population x1, T2_forindex_rep_population x2 ) ;
extern Rep_population mk1_rep_population ( Chromosom x1 );
extern Rep_population rmv1d_rep_population ( Rep_population x1 , Nat1 x2 );
extern Rep_population copy_rep_population ( Rep_population x1 );
extern Nat0 index_rep_population ( Rep_population x1 , Chromosom x2 );
extern Cvtext_vdmlib cvlines_rep_population ( Rep_population x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_population conc_rep_population ( Rep_population x1 , Rep_population x2 );
extern Rep_population tld_rep_population ( Rep_population x1 );
extern void del_rep_population ( Rep_population x1 );
extern void del1_rep_population ( Rep_population x1 );
extern Rep_population appr_rep_population ( Rep_population x1 , Chromosom x2 );
extern Rep_population sub_tupd_rep_population ( Rep_population x1 , Nat1 x2 , Nat0 x3 );
extern Chromosom alloc_chromosom ( void );
extern void free_chromosom ( Chromosom x1 );

#define ref_chromosom(x1) (x1)

extern void profile_chromosom ( void );

typedef void (* T2_forall_rep_chromosom) ( Real y1 ) ;
extern void forall_rep_chromosom ( Rep_chromosom x1, T2_forall_rep_chromosom x2 ) ;

extern Cvtext_vdmlib cvlines1_rep_chromosom ( Rep_chromosom x1 );

extern void del_rep_chromosom ( Rep_chromosom x1 );
extern Rep_chromosom appr_rep_chromosom ( Rep_chromosom x1 , Real x2 );
extern Cvtext_vdmlib cvlines_rep_chromosom ( Rep_chromosom x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_chromosom ovwrt1d_rep_chromosom ( Rep_chromosom x1 , Nat1 x2 , Real x3 );
extern Rep_chromosom copy_rep_chromosom ( Rep_chromosom x1 );
extern Rep_chromosom sub_tupd_rep_chromosom ( Rep_chromosom x1 , Nat1 x2 , Nat0 x3 );
extern Rep_chromosom conc_rep_chromosom ( Rep_chromosom x1 , Rep_chromosom x2 );
extern Rep_chromosom tld_rep_chromosom ( Rep_chromosom x1 );
extern Rep_chromosom mk1_rep_chromosom ( Real x1 );
extern Bool is_eq_rep_chromosom ( Rep_chromosom x1 , Rep_chromosom x2 );
extern void del1_rep_chromosom ( Rep_chromosom x1 );
extern Zeile alloc_zeile ( void );
extern void free_zeile ( Zeile x1 );

#define ref_zeile(x1) (x1)

extern void profile_zeile ( void );

typedef void (* T2_forall_rep_zeile) ( Spalte y1 ) ;
extern void forall_rep_zeile ( Rep_zeile x1, T2_forall_rep_zeile x2 ) ;
extern Rep_zeile sub_tupd_rep_zeile ( Rep_zeile x1 , Nat1 x2 , Nat0 x3 );
extern void del_rep_zeile ( Rep_zeile x1 );
extern Rep_zeile appr_rep_zeile ( Rep_zeile x1 , Spalte x2 );
extern Cvtext_vdmlib cvlines_rep_zeile ( Rep_zeile x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_zeile copy_rep_zeile ( Rep_zeile x1 );
extern Rep_zeile conc_rep_zeile ( Rep_zeile x1 , Rep_zeile x2 );
extern Rep_zeile tld_rep_zeile ( Rep_zeile x1 );
extern Rep_zeile mk1_rep_zeile ( Spalte x1 );

extern Cvtext_vdmlib cvlines1_rep_zeile ( Rep_zeile x1 );

extern void del1_rep_zeile ( Rep_zeile x1 );
extern Spalte alloc_spalte ( void );
extern void free_spalte ( Spalte x1 );

#define ref_spalte(x1) (x1)

extern void profile_spalte ( void );

typedef void (* T2_forall_rep_spalte) ( Real y1 ) ;
extern void forall_rep_spalte ( Rep_spalte x1, T2_forall_rep_spalte x2 ) ;
extern Rep_spalte sub_tupd_rep_spalte ( Rep_spalte x1 , Nat1 x2 , Nat0 x3 );
extern void del_rep_spalte ( Rep_spalte x1 );
extern Rep_spalte appr_rep_spalte ( Rep_spalte x1 , Real x2 );
extern Cvtext_vdmlib cvlines_rep_spalte ( Rep_spalte x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_spalte copy_rep_spalte ( Rep_spalte x1 );
extern Rep_spalte conc_rep_spalte ( Rep_spalte x1 , Rep_spalte x2 );
extern Rep_spalte tld_rep_spalte ( Rep_spalte x1 );
extern Rep_spalte mk1_rep_spalte ( Real x1 );

extern Cvtext_vdmlib cvlines1_rep_spalte ( Rep_spalte x1 );

extern void del1_rep_spalte ( Rep_spalte x1 );
extern Fitness alloc_fitness ( void );
extern void free_fitness ( Fitness x1 );

#define ref_fitness(x1) (x1)

extern void profile_fitness ( void );

typedef void (* T2_forall_rep_fitness) ( Real y1 ) ;
extern void forall_rep_fitness ( Rep_fitness x1, T2_forall_rep_fitness x2 ) ;

extern Cvtext_vdmlib cvlines1_rep_fitness ( Rep_fitness x1 );

typedef void (* T2_forindex_rep_fitness) ( Real y1, Nat1 y2 ) ;
extern void forindex_rep_fitness ( Rep_fitness x1, T2_forindex_rep_fitness x2 ) ;
extern Rep_fitness mk1_rep_fitness ( Real x1 );
extern Rep_fitness rmv1d_rep_fitness ( Rep_fitness x1 , Nat1 x2 );
extern Rep_fitness copy_rep_fitness ( Rep_fitness x1 );
extern Cvtext_vdmlib cvlines_rep_fitness ( Rep_fitness x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_fitness conc_rep_fitness ( Rep_fitness x1 , Rep_fitness x2 );
extern Rep_fitness tld_rep_fitness ( Rep_fitness x1 );
extern void del_rep_fitness ( Rep_fitness x1 );
extern void del1_rep_fitness ( Rep_fitness x1 );
extern Rep_fitness appr_rep_fitness ( Rep_fitness x1 , Real x2 );
extern Rep_fitness sub_tupd_rep_fitness ( Rep_fitness x1 , Nat1 x2 , Nat0 x3 );
extern void del_population ( Population x1 );
extern Nat0 len_population ( Population x1 );
extern Population appr_population ( Population x1 , Chromosom x2 );
extern Population copy1_population ( Population x1 );
extern Population appl_population ( Chromosom x1 , Population x2 );
extern Bool is_empty_population ( Population x1 );
extern Cvtext_vdmlib cvlines_population ( Population x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Nat0 index_population ( Population x1 , Chromosom x2 );
#ifdef __cplusplus
extern void fpr_population ( ostream & x1 , Population x2 );
#else
extern void fpr_population ( FILE *x1 , Population x2 );
#endif
extern Population rmv1_population ( Population x1 , Nat1 x2 );
extern Population mk_empty_population ( void );
extern Chromosom hd_population ( Population x1 );
extern Population conc_population ( Population x1 , Population x2 );
extern void del1_population ( Population x1 );
extern Population tl_population ( Population x1 );
extern Chromosom sel_population ( Population x1 , Nat1 x2 );
extern Population mk1_population ( Chromosom x1 );
extern Bool is_eq_chromosom ( Chromosom x1 , Chromosom x2 );
extern void del_chromosom ( Chromosom x1 );
extern Nat0 len_chromosom ( Chromosom x1 );
extern Chromosom appr_chromosom ( Chromosom x1 , Real x2 );
extern Chromosom copy1_chromosom ( Chromosom x1 );
extern Chromosom appl_chromosom ( Real x1 , Chromosom x2 );
extern Bool is_empty_chromosom ( Chromosom x1 );
extern Cvtext_vdmlib cvlines_chromosom ( Chromosom x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Chromosom ovwrt1_chromosom ( Chromosom x1 , Nat1 x2 , Real x3 );
#ifdef __cplusplus
extern void fpr_chromosom ( ostream & x1 , Chromosom x2 );
#else
extern void fpr_chromosom ( FILE *x1 , Chromosom x2 );
#endif
extern Chromosom sub_tup_chromosom ( Chromosom x1 , Nat1 x2 , Nat0 x3 );
extern Chromosom mk_empty_chromosom ( void );
extern Real hd_chromosom ( Chromosom x1 );
extern Chromosom conc_chromosom ( Chromosom x1 , Chromosom x2 );
extern void del1_chromosom ( Chromosom x1 );
extern Chromosom tl_chromosom ( Chromosom x1 );
extern Real sel_chromosom ( Chromosom x1 , Nat1 x2 );
extern Chromosom mk1_chromosom ( Real x1 );
extern Chromosom copy_chromosom ( Chromosom x1 );
extern void del_zeile ( Zeile x1 );
extern Nat0 len_zeile ( Zeile x1 );
extern Zeile appr_zeile ( Zeile x1 , Spalte x2 );
extern Zeile copy1_zeile ( Zeile x1 );
extern Zeile appl_zeile ( Spalte x1 , Zeile x2 );
extern Bool is_empty_zeile ( Zeile x1 );
extern Cvtext_vdmlib cvlines_zeile ( Zeile x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_zeile ( ostream & x1 , Zeile x2 );
#else
extern void fpr_zeile ( FILE *x1 , Zeile x2 );
#endif
extern Zeile mk_empty_zeile ( void );
extern Spalte hd_zeile ( Zeile x1 );
extern Zeile conc_zeile ( Zeile x1 , Zeile x2 );
extern void del1_zeile ( Zeile x1 );
extern Zeile tl_zeile ( Zeile x1 );
extern Spalte sel_zeile ( Zeile x1 , Nat1 x2 );
extern Zeile mk1_zeile ( Spalte x1 );
extern Spalte copy_spalte ( Spalte x1 );
extern Spalte mk1_spalte ( Real x1 );
extern Real sel_spalte ( Spalte x1 , Nat1 x2 );
extern Spalte tl_spalte ( Spalte x1 );
extern void del1_spalte ( Spalte x1 );
extern Spalte conc_spalte ( Spalte x1 , Spalte x2 );
extern Real hd_spalte ( Spalte x1 );
extern Spalte mk_empty_spalte ( void );
#ifdef __cplusplus
extern void fpr_spalte ( ostream & x1 , Spalte x2 );
#else
extern void fpr_spalte ( FILE *x1 , Spalte x2 );
#endif
extern Cvtext_vdmlib cvlines_spalte ( Spalte x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Bool is_empty_spalte ( Spalte x1 );
extern Spalte appl_spalte ( Real x1 , Spalte x2 );
extern Spalte copy1_spalte ( Spalte x1 );
extern Spalte appr_spalte ( Spalte x1 , Real x2 );
extern Nat0 len_spalte ( Spalte x1 );
extern void del_spalte ( Spalte x1 );
extern void del_fitness ( Fitness x1 );
extern Nat0 len_fitness ( Fitness x1 );
extern Fitness appr_fitness ( Fitness x1 , Real x2 );
extern Fitness copy1_fitness ( Fitness x1 );
extern Fitness appl_fitness ( Real x1 , Fitness x2 );
extern Bool is_empty_fitness ( Fitness x1 );
extern Cvtext_vdmlib cvlines_fitness ( Fitness x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_fitness ( ostream & x1 , Fitness x2 );
#else
extern void fpr_fitness ( FILE *x1 , Fitness x2 );
#endif
extern Fitness rmv1_fitness ( Fitness x1 , Nat1 x2 );
extern Fitness mk_empty_fitness ( void );
extern Real hd_fitness ( Fitness x1 );
extern Fitness conc_fitness ( Fitness x1 , Fitness x2 );
extern void del1_fitness ( Fitness x1 );
extern Fitness tl_fitness ( Fitness x1 );
extern Real sel_fitness ( Fitness x1 , Nat1 x2 );
extern Fitness mk1_fitness ( Real x1 );

/* ------- PHASE4 ------------------ */
#define mk_empty_rep_fitness() alloc_rep_fitness((Nat0)0)
#define sel_rep_fitness(x1,x2) (*( ((Real *)((x1) + 1)) + x2 -1))
#define appl_rep_fitness(x1,x2) conc_rep_fitness(mk1_rep_fitness(x1),x2)
#define is_empty_rep_fitness(x1) (! (ref_rep_fitness((x1))->f_len) )
#define hd_rep_fitness(x1) sel_rep_fitness(x1,(Nat1)1)

#define len_rep_fitness(x1) (ref_rep_fitness((x1))->f_len)

#define len_rep_spalte(x1) (ref_rep_spalte((x1))->f_len)
#define appl_rep_spalte(x1,x2) conc_rep_spalte(mk1_rep_spalte(x1),x2)
#define is_empty_rep_spalte(x1) (! (ref_rep_spalte((x1))->f_len) )
#define mk_empty_rep_spalte() alloc_rep_spalte((Nat0)0)
#define hd_rep_spalte(x1) sel_rep_spalte(x1,(Nat1)1)
#define sel_rep_spalte(x1,x2) (*( ((Real *)((x1) + 1)) + x2 -1))

#define len_rep_zeile(x1) (ref_rep_zeile((x1))->f_len)
#define appl_rep_zeile(x1,x2) conc_rep_zeile(mk1_rep_zeile(x1),x2)
#define is_empty_rep_zeile(x1) (! (ref_rep_zeile((x1))->f_len) )
#define mk_empty_rep_zeile() alloc_rep_zeile((Nat0)0)
#define hd_rep_zeile(x1) sel_rep_zeile(x1,(Nat1)1)
#define sel_rep_zeile(x1,x2) (*( ((Spalte *)((x1) + 1)) + x2 -1))

#define len_rep_chromosom(x1) (ref_rep_chromosom((x1))->f_len)
#define appl_rep_chromosom(x1,x2) conc_rep_chromosom(mk1_rep_chromosom(x1),x2)
#define is_empty_rep_chromosom(x1) (! (ref_rep_chromosom((x1))->f_len) )
#define mk_empty_rep_chromosom() alloc_rep_chromosom((Nat0)0)
#define hd_rep_chromosom(x1) sel_rep_chromosom(x1,(Nat1)1)
#define sel_rep_chromosom(x1,x2) (*( ((Real *)((x1) + 1)) + x2 -1))
#define mk_empty_rep_population() alloc_rep_population((Nat0)0)
#define sel_rep_population(x1,x2) (*( ((Chromosom *)((x1) + 1)) + x2 -1))
#define appl_rep_population(x1,x2) conc_rep_population(mk1_rep_population(x1),x2)
#define is_empty_rep_population(x1) (! (ref_rep_population((x1))->f_len) )
#define hd_rep_population(x1) sel_rep_population(x1,(Nat1)1)

#define len_rep_population(x1) (ref_rep_population((x1))->f_len)
#define is_empty_iter_fitness(x1) is_empty_iter_rep_fitness(&((x1)->f_ir))
#define del_iter_fitness(x1) del_fitness((x1).f_vl)
#define sel_iter_fitness(x1) copy_real(sel_iter_rep_fitness(&((x1)->f_ir)))
#define next_iter_fitness(x1) next_iter_rep_fitness(&((x1)->f_ir))
#define is_empty_iter_spalte(x1) is_empty_iter_rep_spalte(&((x1)->f_ir))
#define del_iter_spalte(x1) del_spalte((x1).f_vl)
#define sel_iter_spalte(x1) copy_real(sel_iter_rep_spalte(&((x1)->f_ir)))
#define next_iter_spalte(x1) next_iter_rep_spalte(&((x1)->f_ir))
#define is_empty_iter_zeile(x1) is_empty_iter_rep_zeile(&((x1)->f_ir))
#define del_iter_zeile(x1) del_zeile((x1).f_vl)
#define sel_iter_zeile(x1) copy_spalte(sel_iter_rep_zeile(&((x1)->f_ir)))
#define next_iter_zeile(x1) next_iter_rep_zeile(&((x1)->f_ir))
#define is_empty_iter_chromosom(x1) is_empty_iter_rep_chromosom(&((x1)->f_ir))
#define del_iter_chromosom(x1) del_chromosom((x1).f_vl)
#define sel_iter_chromosom(x1) copy_real(sel_iter_rep_chromosom(&((x1)->f_ir)))
#define next_iter_chromosom(x1) next_iter_rep_chromosom(&((x1)->f_ir))
#define is_empty_iter_population(x1) is_empty_iter_rep_population(&((x1)->f_ir))
#define del_iter_population(x1) del_population((x1).f_vl)
#define sel_iter_population(x1) copy_chromosom(sel_iter_rep_population(&((x1)->f_ir)))
#define next_iter_population(x1) next_iter_rep_population(&((x1)->f_ir))
#define del_iter_rep_fitness(x1)
#define is_empty_iter_rep_fitness(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_spalte(x1)
#define is_empty_iter_rep_spalte(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_zeile(x1)
#define is_empty_iter_rep_zeile(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_chromosom(x1)
#define is_empty_iter_rep_chromosom(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_population(x1)
#define is_empty_iter_rep_population(x1) ((x1)->f_curser == (x1)->f_array->f_len)

#endif
