#ifndef CPP_header_tsp
#define CPP_header_tsp
/* ------- PHASE1 ------------------ */

#include "tsp.h"

/*
module generated from VDM Class Library
$Revision: 1.1 $
$Date: 1996/07/04 07:44:16 $
*/
class VDMLIB;
class BOOL;
class NILETC;
class STDLIB;
class REAL;
class NAT1;
class NAT0;
class INTG;
class CHAR;
class ITER_POPULATION;
class ITER_CHROMOSOM;
class ITER_ZEILE;
class ITER_SPALTE;
class ITER_FITNESS;
class STR;
class POPULATION;
class CHROMOSOM;
class ZEILE;
class SPALTE;
class FITNESS;

/* ------- PHASE2 ------------------ */
class VDMLIB {
};
class BOOL {
public:
Bool data;
BOOL() {}
BOOL (int x1) { data = (Bool)x1; }
BOOL & operator=(int x1) { data = (Bool)x1; return *this; }
BOOL (const BOOL & x1) { data = x1.data; }
BOOL & operator=(const BOOL & x1) { data = x1.data; return *this; }

operator int() const { return (int)data; }

Bool cv_bool() const { return data; }

inline BOOL and (const BOOL & x2)
;

inline BOOL & operator &= (const BOOL & x2)
;

inline BOOL operator & (const BOOL & x2)
;

inline BOOL is_eq (const BOOL & x2) const
;

inline BOOL operator == (const BOOL & x2) const
;

inline BOOL operator != (const BOOL & x2) const
;

inline BOOL is_ge (const BOOL & x2) const
;

inline BOOL operator >= (const BOOL & x2) const
;

inline BOOL or (const BOOL & x2)
;

inline BOOL & operator |= (const BOOL & x2)
;

inline BOOL operator | (const BOOL & x2)
;

inline BOOL not () const
;

inline BOOL operator ! () const
;

inline BOOL is_gr (const BOOL & x2) const
;

inline BOOL operator > (const BOOL & x2) const
;

inline BOOL xor (const BOOL & x2)
;

inline BOOL & operator ^= (const BOOL & x2)
;

inline BOOL operator ^ (const BOOL & x2)
;

};
class NILETC {
};

#ifndef STDLIB_CL
#define STDLIB_CL
class STDLIB {

};
#endif
class REAL {
public:
Real data;
REAL () {}
REAL (Real x1) { data = x1; }
REAL & operator=(Real x1) { data = x1; return *this; }
REAL (const REAL & x1) { data = x1.data; }
REAL & operator=(const REAL & x1) { data = x1.data; return *this; }

Real cv_real() const { return data; }

inline void del ()
;

inline REAL copy () const
;

inline REAL pred ()
;

inline REAL & operator -- ()
;

inline REAL operator -- (int)
;

inline BOOL is_eq (const REAL & x2) const
;

inline BOOL operator == (const REAL & x2) const
;

inline BOOL operator != (const REAL & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const REAL & x2) const
;

inline BOOL operator < (const REAL & x2) const
;

inline BOOL is_ge (const REAL & x2) const
;

inline BOOL operator >= (const REAL & x2) const
;

inline REAL times (const REAL & x2)
;

inline REAL & operator *= (const REAL & x2)
;

inline REAL operator * (const REAL & x2) const
;

inline REAL plus (const REAL & x2)
;

inline REAL & operator += (const REAL & x2)
;

inline REAL operator + (const REAL & x2) const
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const REAL & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline REAL succ ()
;

inline REAL & operator ++ ()
;

inline REAL operator ++ (int)
;

inline BOOL is_le (const REAL & x2) const
;

inline BOOL operator <= (const REAL & x2) const
;

inline BOOL is_gr (const REAL & x2) const
;

inline BOOL operator > (const REAL & x2) const
;

inline REAL div (const REAL & x2)
;

inline REAL & operator /= (const REAL & x2)
;

inline REAL operator / (const REAL & x2) const
;

inline REAL minus (const REAL & x2)
;

inline REAL & operator -= (const REAL & x2)
;

inline REAL operator - (const REAL & x2) const
;

inline void set_print_format (char * x1) const
;

inline void set_print_format () const
;
};
class NAT1 {
public:
Nat1 data;
NAT1 () {}
NAT1 (Nat1 x1) { data = x1; }
NAT1 & operator=(Nat1 x1) { data = x1; return *this; }
NAT1 (const NAT1 & x1) { data = x1.data; }
NAT1 & operator=(const NAT1 & x1) { data = x1.data; return *this; }

Nat1 cv_nat1() const { return data; }

NAT1 (const NAT0 & x1);

operator NAT0 () const;

inline NAT1 minus (const NAT1 & x2)
;

inline NAT1 & operator -= (const NAT1 & x2)
;

inline NAT1 operator - (const NAT1 & x2) const
;

inline NAT1 div (const NAT1 & x2)
;

inline NAT1 & operator /= (const NAT1 & x2)
;

inline NAT1 operator / (const NAT1 & x2) const
;

inline BOOL is_gr (const NAT1 & x2) const
;

inline BOOL operator > (const NAT1 & x2) const
;

inline BOOL is_le (const NAT1 & x2) const
;

inline BOOL operator <= (const NAT1 & x2) const
;

inline NAT1 mod (const NAT1 & x2)
;

inline NAT1 & operator %= (const NAT1 & x2)
;

inline NAT1 operator % (const NAT1 & x2) const
;

inline NAT1 succ ()
;

inline NAT1 & operator ++ ()
;

inline NAT1 operator ++ (int)
;

inline NAT1 plus (const NAT1 & x2)
;

inline NAT1 & operator += (const NAT1 & x2)
;

inline NAT1 operator + (const NAT1 & x2) const
;

inline NAT1 times (const NAT1 & x2)
;

inline NAT1 & operator *= (const NAT1 & x2)
;

inline NAT1 operator * (const NAT1 & x2) const
;

inline BOOL is_ge (const NAT1 & x2) const
;

inline BOOL operator >= (const NAT1 & x2) const
;

inline BOOL is_lt (const NAT1 & x2) const
;

inline BOOL operator < (const NAT1 & x2) const
;

inline BOOL is_eq (const NAT1 & x2) const
;

inline BOOL operator == (const NAT1 & x2) const
;

inline BOOL operator != (const NAT1 & x2) const
;

inline BOOL operator ! () const
;

inline NAT1 pred ()
;

inline NAT1 & operator -- ()
;

inline NAT1 operator -- (int)
;

};
class NAT0 {
public:
Nat0 data;
NAT0 () {}
NAT0 (Nat0 x1) { data = x1; }
NAT0 & operator=(Nat0 x1) { data = x1; return *this; }
NAT0 (const NAT0 & x1) { data = x1.data; }
NAT0 & operator=(const NAT0 & x1) { data = x1.data; return *this; }

Nat0 cv_nat0() const { return data; }

NAT0 (const INTG & x1);

inline NAT0 minus (const NAT0 & x2)
;

inline NAT0 & operator -= (const NAT0 & x2)
;

inline NAT0 operator - (const NAT0 & x2) const
;

inline NAT0 div (const NAT0 & x2)
;

inline NAT0 & operator /= (const NAT0 & x2)
;

inline NAT0 operator / (const NAT0 & x2) const
;

inline BOOL is_gr (const NAT0 & x2) const
;

inline BOOL operator > (const NAT0 & x2) const
;

inline BOOL is_le (const NAT0 & x2) const
;

inline BOOL operator <= (const NAT0 & x2) const
;

inline NAT0 mod (const NAT0 & x2)
;

inline NAT0 & operator %= (const NAT0 & x2)
;

inline NAT0 operator % (const NAT0 & x2) const
;

inline NAT0 succ ()
;

inline NAT0 & operator ++ ()
;

inline NAT0 operator ++ (int)
;

inline NAT0 plus (const NAT0 & x2)
;

inline NAT0 & operator += (const NAT0 & x2)
;

inline NAT0 operator + (const NAT0 & x2) const
;

inline NAT0 times (const NAT0 & x2)
;

inline NAT0 & operator *= (const NAT0 & x2)
;

inline NAT0 operator * (const NAT0 & x2) const
;

inline BOOL is_ge (const NAT0 & x2) const
;

inline BOOL operator >= (const NAT0 & x2) const
;

inline BOOL is_lt (const NAT0 & x2) const
;

inline BOOL operator < (const NAT0 & x2) const
;

inline BOOL is_eq (const NAT0 & x2) const
;

inline BOOL operator == (const NAT0 & x2) const
;

inline BOOL operator != (const NAT0 & x2) const
;

inline BOOL operator ! () const
;

inline NAT0 pred ()
;

inline NAT0 & operator -- ()
;

inline NAT0 operator -- (int)
;

};
class INTG {
public:
Intg data;
INTG () {}
INTG (Intg x1) { data = x1; }
INTG & operator=(Intg x1) { data = x1; return *this; }
INTG (const INTG & x1) { data = x1.data; }
INTG & operator=(const INTG & x1) { data = x1.data; return *this; }

Intg cv_intg() const { return data; }

INTG (const NAT0 & x1);

inline INTG minus (const INTG & x2)
;

inline INTG & operator -= (const INTG & x2)
;

inline INTG operator - (const INTG & x2) const
;

inline INTG div (const INTG & x2)
;

inline INTG & operator /= (const INTG & x2)
;

inline INTG operator / (const INTG & x2) const
;

inline BOOL is_gr (const INTG & x2) const
;

inline BOOL operator > (const INTG & x2) const
;

inline BOOL is_le (const INTG & x2) const
;

inline BOOL operator <= (const INTG & x2) const
;

inline INTG mod (const INTG & x2)
;

inline INTG & operator %= (const INTG & x2)
;

inline INTG operator % (const INTG & x2) const
;

inline INTG succ ()
;

inline INTG & operator ++ ()
;

inline INTG operator ++ (int)
;

inline INTG plus (const INTG & x2)
;

inline INTG & operator += (const INTG & x2)
;

inline INTG operator + (const INTG & x2) const
;

inline INTG times (const INTG & x2)
;

inline INTG & operator *= (const INTG & x2)
;

inline INTG operator * (const INTG & x2) const
;

inline BOOL is_ge (const INTG & x2) const
;

inline BOOL operator >= (const INTG & x2) const
;

inline BOOL is_lt (const INTG & x2) const
;

inline BOOL operator < (const INTG & x2) const
;

inline BOOL is_eq (const INTG & x2) const
;

inline BOOL operator == (const INTG & x2) const
;

inline BOOL operator != (const INTG & x2) const
;

inline BOOL operator ! () const
;

inline INTG pred ()
;

inline INTG & operator -- ()
;

inline INTG operator -- (int)
;

};
class CHAR {
public:
Char data;
CHAR () {}
CHAR (Char x1) { data = x1; }
CHAR & operator=(Char x1) { data = x1; return *this; }
CHAR (const CHAR & x1) { data = x1.data; }
CHAR & operator=(const CHAR & x1) { data = x1.data; return *this; }

Char cv_char() const { return data; }

CHAR (const NAT0 & x1);

operator NAT0 () const;

inline void del ()
;

inline CHAR minus (const CHAR & x2)
;

inline CHAR & operator -= (const CHAR & x2)
;

inline CHAR operator - (const CHAR & x2) const
;

inline CHAR div (const CHAR & x2)
;

inline CHAR & operator /= (const CHAR & x2)
;

inline CHAR operator / (const CHAR & x2) const
;

inline BOOL is_gr (const CHAR & x2) const
;

inline BOOL operator > (const CHAR & x2) const
;

inline BOOL is_le (const CHAR & x2) const
;

inline BOOL operator <= (const CHAR & x2) const
;

inline CHAR mod (const CHAR & x2)
;

inline CHAR & operator %= (const CHAR & x2)
;

inline CHAR operator % (const CHAR & x2) const
;

inline CHAR succ ()
;

inline CHAR & operator ++ ()
;

inline CHAR operator ++ (int)
;

inline CHAR plus (const CHAR & x2)
;

inline CHAR & operator += (const CHAR & x2)
;

inline CHAR operator + (const CHAR & x2) const
;

inline CHAR times (const CHAR & x2)
;

inline CHAR & operator *= (const CHAR & x2)
;

inline CHAR operator * (const CHAR & x2) const
;

inline BOOL is_ge (const CHAR & x2) const
;

inline BOOL operator >= (const CHAR & x2) const
;

inline BOOL is_lt (const CHAR & x2) const
;

inline BOOL operator < (const CHAR & x2) const
;

inline BOOL is_eq (const CHAR & x2) const
;

inline BOOL operator == (const CHAR & x2) const
;

inline BOOL operator != (const CHAR & x2) const
;

inline BOOL operator ! () const
;

inline CHAR pred ()
;

inline CHAR & operator -- ()
;

inline CHAR operator -- (int)
;

inline CHAR copy () const
;
};
class ITER_POPULATION {
public:
Iter_population data;
~ITER_POPULATION() { del_iter_population(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_POPULATION (POPULATION x1)
;
inline CHROMOSOM sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_CHROMOSOM {
public:
Iter_chromosom data;
~ITER_CHROMOSOM() { del_iter_chromosom(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_CHROMOSOM (CHROMOSOM x1)
;
inline REAL sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_ZEILE {
public:
Iter_zeile data;
~ITER_ZEILE() { del_iter_zeile(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_ZEILE (ZEILE x1)
;
inline SPALTE sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_SPALTE {
public:
Iter_spalte data;
~ITER_SPALTE() { del_iter_spalte(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_SPALTE (SPALTE x1)
;
inline REAL sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_FITNESS {
public:
Iter_fitness data;
~ITER_FITNESS() { del_iter_fitness(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_FITNESS (FITNESS x1)
;
inline REAL sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class STR {
public:
Str data;

STR()
{
data = 0;
/* == non valid handle */
}

~STR() { del_str(data); }

STR(const STR & x1)
{
check_handle_str(x1.data);
data = x1.data;
data->f_rc++;
}

STR(const Str &x1)
{
check_handle_str(x1);
data = x1;

}

STR & operator=(const STR & x1)
{
check_handle_str(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_str(data);
data = x1.data;
return *this;
}

Str cv_str() const
{
check_handle_str(data);
data->f_rc++;
return data;
}

inline NAT0 len () const
;
inline NAT0 index (const CHAR & x2) const
;
inline CHAR hd () const
;

inline STR & conc (const STR & x2)
;

inline STR & operator += (const STR & x2)
;

inline STR operator + (const STR & x2) const
;

inline CHAR sel (const NAT1 & x2) const
;
 CHAR operator [] (const NAT1 & x2) const
;
inline void cpc (char * x2) const
;
inline STR (char * x1)
;

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */
inline STR & ovwrt1 (const NAT1 & x2, const CHAR & x3)
;
inline STR (const CHAR & x1, const NAT0 & x2)
;
};
class POPULATION {
public:
Population data;

POPULATION()
{
data = 0;
/* == non valid handle */
}

~POPULATION() { del_population(data); }

POPULATION(const POPULATION & x1)
{
check_handle_population(x1.data);
data = x1.data;
data->f_rc++;
}

POPULATION(const Population &x1)
{
check_handle_population(x1);
data = x1;

}

POPULATION & operator=(const POPULATION & x1)
{
check_handle_population(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_population(data);
data = x1.data;
return *this;
}

Population cv_population() const
{
check_handle_population(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 len () const
;

inline POPULATION & appr (const CHROMOSOM & x2)
;

inline POPULATION & operator += (const CHROMOSOM & x2)
;

inline POPULATION operator + (const CHROMOSOM & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline POPULATION & appl (const CHROMOSOM & x1)
;
inline friend POPULATION operator + (const CHROMOSOM & x1, POPULATION & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline NAT0 index (const CHROMOSOM & x2) const
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const POPULATION & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline POPULATION & rmv1 (const NAT1 & x2)
;
inline POPULATION (const NILETC & x1)
;
inline CHROMOSOM hd () const
;

inline POPULATION & conc (const POPULATION & x2)
;

inline POPULATION & operator += (const POPULATION & x2)
;

inline POPULATION operator + (const POPULATION & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline POPULATION & tl ()
;
inline CHROMOSOM sel (const NAT1 & x2) const
;
 CHROMOSOM operator [] (const NAT1 & x2) const
;
inline POPULATION (const CHROMOSOM & x1)
;

};
class CHROMOSOM {
public:
Chromosom data;

CHROMOSOM()
{
data = 0;
/* == non valid handle */
}

~CHROMOSOM() { del_chromosom(data); }

CHROMOSOM(const CHROMOSOM & x1)
{
check_handle_chromosom(x1.data);
data = x1.data;
data->f_rc++;
}

CHROMOSOM(const Chromosom &x1)
{
check_handle_chromosom(x1);
data = x1;

}

CHROMOSOM & operator=(const CHROMOSOM & x1)
{
check_handle_chromosom(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_chromosom(data);
data = x1.data;
return *this;
}

Chromosom cv_chromosom() const
{
check_handle_chromosom(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const CHROMOSOM & x2) const
;

inline BOOL operator == (const CHROMOSOM & x2) const
;

inline BOOL operator != (const CHROMOSOM & x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline NAT0 len () const
;

inline CHROMOSOM & appr (const REAL & x2)
;

inline CHROMOSOM & operator += (const REAL & x2)
;

inline CHROMOSOM operator + (const REAL & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline CHROMOSOM & appl (const REAL & x1)
;
inline friend CHROMOSOM operator + (const REAL & x1, CHROMOSOM & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline CHROMOSOM & ovwrt1 (const NAT1 & x2, const REAL & x3)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const CHROMOSOM & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CHROMOSOM & sub_tup (const NAT1 & x2, const NAT0 & x3)
;
inline CHROMOSOM (const NILETC & x1)
;
inline REAL hd () const
;

inline CHROMOSOM & conc (const CHROMOSOM & x2)
;

inline CHROMOSOM & operator += (const CHROMOSOM & x2)
;

inline CHROMOSOM operator + (const CHROMOSOM & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOM & tl ()
;
inline REAL sel (const NAT1 & x2) const
;
 REAL operator [] (const NAT1 & x2) const
;
inline CHROMOSOM (const REAL & x1)
;

/* === Member function 'copy' not required for automem implementations === */
};
class ZEILE {
public:
Zeile data;

ZEILE()
{
data = 0;
/* == non valid handle */
}

~ZEILE() { del_zeile(data); }

ZEILE(const ZEILE & x1)
{
check_handle_zeile(x1.data);
data = x1.data;
data->f_rc++;
}

ZEILE(const Zeile &x1)
{
check_handle_zeile(x1);
data = x1;

}

ZEILE & operator=(const ZEILE & x1)
{
check_handle_zeile(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_zeile(data);
data = x1.data;
return *this;
}

Zeile cv_zeile() const
{
check_handle_zeile(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 len () const
;

inline ZEILE & appr (const SPALTE & x2)
;

inline ZEILE & operator += (const SPALTE & x2)
;

inline ZEILE operator + (const SPALTE & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline ZEILE & appl (const SPALTE & x1)
;
inline friend ZEILE operator + (const SPALTE & x1, ZEILE & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const ZEILE & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline ZEILE (const NILETC & x1)
;
inline SPALTE hd () const
;

inline ZEILE & conc (const ZEILE & x2)
;

inline ZEILE & operator += (const ZEILE & x2)
;

inline ZEILE operator + (const ZEILE & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline ZEILE & tl ()
;
inline SPALTE sel (const NAT1 & x2) const
;
 SPALTE operator [] (const NAT1 & x2) const
;
inline ZEILE (const SPALTE & x1)
;

};
class SPALTE {
public:
Spalte data;

SPALTE()
{
data = 0;
/* == non valid handle */
}

~SPALTE() { del_spalte(data); }

SPALTE(const SPALTE & x1)
{
check_handle_spalte(x1.data);
data = x1.data;
data->f_rc++;
}

SPALTE(const Spalte &x1)
{
check_handle_spalte(x1);
data = x1;

}

SPALTE & operator=(const SPALTE & x1)
{
check_handle_spalte(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_spalte(data);
data = x1.data;
return *this;
}

Spalte cv_spalte() const
{
check_handle_spalte(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */
inline SPALTE (const REAL & x1)
;

inline REAL sel (const NAT1 & x2) const
;
 REAL operator [] (const NAT1 & x2) const
;
inline SPALTE & tl ()
;

/* Member function 'del1' not required for automem implementations */

inline SPALTE & conc (const SPALTE & x2)
;

inline SPALTE & operator += (const SPALTE & x2)
;

inline SPALTE operator + (const SPALTE & x2) const
;

inline REAL hd () const
;
inline SPALTE (const NILETC & x1)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const SPALTE & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline SPALTE & appl (const REAL & x1)
;
inline friend SPALTE operator + (const REAL & x1, SPALTE & x2)
;

/* Member function 'copy1' not required for automem implementations */

inline SPALTE & appr (const REAL & x2)
;

inline SPALTE & operator += (const REAL & x2)
;

inline SPALTE operator + (const REAL & x2) const
;

inline NAT0 len () const
;

/* === Member function 'del' not required for automem implementations === */

};
class FITNESS {
public:
Fitness data;

FITNESS()
{
data = 0;
/* == non valid handle */
}

~FITNESS() { del_fitness(data); }

FITNESS(const FITNESS & x1)
{
check_handle_fitness(x1.data);
data = x1.data;
data->f_rc++;
}

FITNESS(const Fitness &x1)
{
check_handle_fitness(x1);
data = x1;

}

FITNESS & operator=(const FITNESS & x1)
{
check_handle_fitness(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_fitness(data);
data = x1.data;
return *this;
}

Fitness cv_fitness() const
{
check_handle_fitness(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 len () const
;

inline FITNESS & appr (const REAL & x2)
;

inline FITNESS & operator += (const REAL & x2)
;

inline FITNESS operator + (const REAL & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline FITNESS & appl (const REAL & x1)
;
inline friend FITNESS operator + (const REAL & x1, FITNESS & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const FITNESS & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline FITNESS & rmv1 (const NAT1 & x2)
;
inline FITNESS (const NILETC & x1)
;
inline REAL hd () const
;

inline FITNESS & conc (const FITNESS & x2)
;

inline FITNESS & operator += (const FITNESS & x2)
;

inline FITNESS operator + (const FITNESS & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline FITNESS & tl ()
;
inline REAL sel (const NAT1 & x2) const
;
 REAL operator [] (const NAT1 & x2) const
;
inline FITNESS (const REAL & x1)
;

};

/* ------- PHASE3 ------------------ */
inline BOOL BOOL :: and (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL & BOOL :: operator &= (const BOOL & x2)
{ data = and_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator & (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL BOOL :: is_eq (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator == (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator != (const BOOL & x2) const
{ return BOOL((Bool)! is_eq_bool (data, x2.data));}

inline BOOL BOOL :: is_ge (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: operator >= (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: or (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

inline BOOL & BOOL :: operator |= (const BOOL & x2)
{ data = or_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator | (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

inline BOOL BOOL :: not () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: operator ! () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: is_gr (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: operator > (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: xor (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

inline BOOL & BOOL :: operator ^= (const BOOL & x2)
{ data = xor_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator ^ (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

extern NILETC empty, nil, new_val;
typedef NILETC * mklc;

inline void REAL :: del ()
{ del_real (data);}

inline REAL REAL :: copy () const
{ return REAL(copy_real (data));}

inline REAL REAL :: pred ()
{ return REAL(pred_real (data));}

inline REAL & REAL :: operator -- ()
{ data = pred_real (data); return *this;}

inline REAL REAL :: operator -- (int)
{ REAL tmp=*this; { data = pred_real (data);}; return tmp; }

inline BOOL REAL :: is_eq (const REAL & x2) const
{ return BOOL(is_eq_real (data, x2.data));}

inline BOOL REAL :: operator == (const REAL & x2) const
{ return BOOL(is_eq_real (data, x2.data));}

inline BOOL REAL :: operator != (const REAL & x2) const
{ return BOOL((Bool)! is_eq_real (data, x2.data));}

inline BOOL REAL :: operator ! () const
{ return BOOL((Bool)! is_eq_real (data,((Real)0)));}

inline BOOL REAL :: is_lt (const REAL & x2) const
{ return BOOL(is_lt_real (data, x2.data));}

inline BOOL REAL :: operator < (const REAL & x2) const
{ return BOOL(is_lt_real (data, x2.data));}

inline BOOL REAL :: is_ge (const REAL & x2) const
{ return BOOL(is_ge_real (data, x2.data));}

inline BOOL REAL :: operator >= (const REAL & x2) const
{ return BOOL(is_ge_real (data, x2.data));}

inline REAL REAL :: times (const REAL & x2)
{ return REAL(times_real (data, x2.data));}

inline REAL & REAL :: operator *= (const REAL & x2)
{ data = times_real (data, x2.data); return *this;}

inline REAL REAL :: operator * (const REAL & x2) const
{ return REAL(times_real (data, x2.data));}

inline REAL REAL :: plus (const REAL & x2)
{ return REAL(plus_real (data, x2.data));}

inline REAL & REAL :: operator += (const REAL & x2)
{ data = plus_real (data, x2.data); return *this;}

inline REAL REAL :: operator + (const REAL & x2) const
{ return REAL(plus_real (data, x2.data));}

inline void REAL :: fpr (ostream & x1) const
{ fpr_real (x1, data);}
inline ostream & operator << (ostream & x1, const REAL & x2)
{ fpr_real (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline REAL REAL :: succ ()
{ return REAL(succ_real (data));}

inline REAL & REAL :: operator ++ ()
{ data = succ_real (data); return *this;}

inline REAL REAL :: operator ++ (int)
{ REAL tmp=*this; { data = succ_real (data);}; return tmp; }

inline BOOL REAL :: is_le (const REAL & x2) const
{ return BOOL(is_le_real (data, x2.data));}

inline BOOL REAL :: operator <= (const REAL & x2) const
{ return BOOL(is_le_real (data, x2.data));}

inline BOOL REAL :: is_gr (const REAL & x2) const
{ return BOOL(is_gr_real (data, x2.data));}

inline BOOL REAL :: operator > (const REAL & x2) const
{ return BOOL(is_gr_real (data, x2.data));}

inline REAL REAL :: div (const REAL & x2)
{ return REAL(div_real (data, x2.data));}

inline REAL & REAL :: operator /= (const REAL & x2)
{ data = div_real (data, x2.data); return *this;}

inline REAL REAL :: operator / (const REAL & x2) const
{ return REAL(div_real (data, x2.data));}

inline REAL REAL :: minus (const REAL & x2)
{ return REAL(minus_real (data, x2.data));}

inline REAL & REAL :: operator -= (const REAL & x2)
{ data = minus_real (data, x2.data); return *this;}

inline REAL REAL :: operator - (const REAL & x2) const
{ return REAL(minus_real (data, x2.data));}

inline void REAL :: set_print_format (char * x1) const
{ set_print_format_real (x1);}

inline void REAL :: set_print_format () const
{ set_print_format_real ((char *)0);}

inline
NAT1 :: NAT1 (const NAT0 & x1)
{
data = Nat1(x1.data);
}
inline
NAT1 :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline NAT1 NAT1 :: minus (const NAT1 & x2)
{ return NAT1(minus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator -= (const NAT1 & x2)
{ data = minus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator - (const NAT1 & x2) const
{ return NAT1(minus_nat1 (data, x2.data));}

inline NAT1 NAT1 :: div (const NAT1 & x2)
{ return NAT1(div_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator /= (const NAT1 & x2)
{ data = div_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator / (const NAT1 & x2) const
{ return NAT1(div_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_gr (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator > (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_le (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator <= (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline NAT1 NAT1 :: mod (const NAT1 & x2)
{ return NAT1(mod_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator %= (const NAT1 & x2)
{ data = mod_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator % (const NAT1 & x2) const
{ return NAT1(mod_nat1 (data, x2.data));}

inline NAT1 NAT1 :: succ ()
{ return NAT1(succ_nat1 (data));}

inline NAT1 & NAT1 :: operator ++ ()
{ data = succ_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator ++ (int)
{ NAT1 tmp=*this; { data = succ_nat1 (data);}; return tmp; }

inline NAT1 NAT1 :: plus (const NAT1 & x2)
{ return NAT1(plus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator += (const NAT1 & x2)
{ data = plus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator + (const NAT1 & x2) const
{ return NAT1(plus_nat1 (data, x2.data));}

inline NAT1 NAT1 :: times (const NAT1 & x2)
{ return NAT1(times_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator *= (const NAT1 & x2)
{ data = times_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator * (const NAT1 & x2) const
{ return NAT1(times_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_ge (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator >= (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_lt (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator < (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_eq (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator == (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator != (const NAT1 & x2) const
{ return BOOL((Bool)! is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat1 (data,((Nat1)0)));}

inline NAT1 NAT1 :: pred ()
{ return NAT1(pred_nat1 (data));}

inline NAT1 & NAT1 :: operator -- ()
{ data = pred_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator -- (int)
{ NAT1 tmp=*this; { data = pred_nat1 (data);}; return tmp; }

inline
NAT0 :: NAT0 (const INTG & x1)
{
data = Nat0(x1.data);
}

inline NAT0 NAT0 :: minus (const NAT0 & x2)
{ return NAT0(minus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator -= (const NAT0 & x2)
{ data = minus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator - (const NAT0 & x2) const
{ return NAT0(minus_nat0 (data, x2.data));}

inline NAT0 NAT0 :: div (const NAT0 & x2)
{ return NAT0(div_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator /= (const NAT0 & x2)
{ data = div_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator / (const NAT0 & x2) const
{ return NAT0(div_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_gr (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator > (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_le (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator <= (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline NAT0 NAT0 :: mod (const NAT0 & x2)
{ return NAT0(mod_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator %= (const NAT0 & x2)
{ data = mod_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator % (const NAT0 & x2) const
{ return NAT0(mod_nat0 (data, x2.data));}

inline NAT0 NAT0 :: succ ()
{ return NAT0(succ_nat0 (data));}

inline NAT0 & NAT0 :: operator ++ ()
{ data = succ_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator ++ (int)
{ NAT0 tmp=*this; { data = succ_nat0 (data);}; return tmp; }

inline NAT0 NAT0 :: plus (const NAT0 & x2)
{ return NAT0(plus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator += (const NAT0 & x2)
{ data = plus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator + (const NAT0 & x2) const
{ return NAT0(plus_nat0 (data, x2.data));}

inline NAT0 NAT0 :: times (const NAT0 & x2)
{ return NAT0(times_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator *= (const NAT0 & x2)
{ data = times_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator * (const NAT0 & x2) const
{ return NAT0(times_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_ge (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator >= (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_lt (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator < (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_eq (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator == (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator != (const NAT0 & x2) const
{ return BOOL((Bool)! is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat0 (data,((Nat0)0)));}

inline NAT0 NAT0 :: pred ()
{ return NAT0(pred_nat0 (data));}

inline NAT0 & NAT0 :: operator -- ()
{ data = pred_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator -- (int)
{ NAT0 tmp=*this; { data = pred_nat0 (data);}; return tmp; }

inline INTG :: INTG (const NAT0 & x1)
{
data = Intg(x1.data);
}

inline INTG INTG :: minus (const INTG & x2)
{ return INTG(minus_intg (data, x2.data));}

inline INTG & INTG :: operator -= (const INTG & x2)
{ data = minus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator - (const INTG & x2) const
{ return INTG(minus_intg (data, x2.data));}

inline INTG INTG :: div (const INTG & x2)
{ return INTG(div_intg (data, x2.data));}

inline INTG & INTG :: operator /= (const INTG & x2)
{ data = div_intg (data, x2.data); return *this;}

inline INTG INTG :: operator / (const INTG & x2) const
{ return INTG(div_intg (data, x2.data));}

inline BOOL INTG :: is_gr (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline BOOL INTG :: operator > (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline BOOL INTG :: is_le (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline BOOL INTG :: operator <= (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline INTG INTG :: mod (const INTG & x2)
{ return INTG(mod_intg (data, x2.data));}

inline INTG & INTG :: operator %= (const INTG & x2)
{ data = mod_intg (data, x2.data); return *this;}

inline INTG INTG :: operator % (const INTG & x2) const
{ return INTG(mod_intg (data, x2.data));}

inline INTG INTG :: succ ()
{ return INTG(succ_intg (data));}

inline INTG & INTG :: operator ++ ()
{ data = succ_intg (data); return *this;}

inline INTG INTG :: operator ++ (int)
{ INTG tmp=*this; { data = succ_intg (data);}; return tmp; }

inline INTG INTG :: plus (const INTG & x2)
{ return INTG(plus_intg (data, x2.data));}

inline INTG & INTG :: operator += (const INTG & x2)
{ data = plus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator + (const INTG & x2) const
{ return INTG(plus_intg (data, x2.data));}

inline INTG INTG :: times (const INTG & x2)
{ return INTG(times_intg (data, x2.data));}

inline INTG & INTG :: operator *= (const INTG & x2)
{ data = times_intg (data, x2.data); return *this;}

inline INTG INTG :: operator * (const INTG & x2) const
{ return INTG(times_intg (data, x2.data));}

inline BOOL INTG :: is_ge (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline BOOL INTG :: operator >= (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline BOOL INTG :: is_lt (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: operator < (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: is_eq (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator == (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator != (const INTG & x2) const
{ return BOOL((Bool)! is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator ! () const
{ return BOOL((Bool)! is_eq_intg (data,((Intg)0)));}

inline INTG INTG :: pred ()
{ return INTG(pred_intg (data));}

inline INTG & INTG :: operator -- ()
{ data = pred_intg (data); return *this;}

inline INTG INTG :: operator -- (int)
{ INTG tmp=*this; { data = pred_intg (data);}; return tmp; }

inline
CHAR :: CHAR (const NAT0 & x1)
{
data = Char(x1.data);
}
inline
CHAR :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline void CHAR :: del ()
{ del_char (data);}

inline CHAR CHAR :: minus (const CHAR & x2)
{ return CHAR(minus_char (data, x2.data));}

inline CHAR & CHAR :: operator -= (const CHAR & x2)
{ data = minus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator - (const CHAR & x2) const
{ return CHAR(minus_char (data, x2.data));}

inline CHAR CHAR :: div (const CHAR & x2)
{ return CHAR(div_char (data, x2.data));}

inline CHAR & CHAR :: operator /= (const CHAR & x2)
{ data = div_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator / (const CHAR & x2) const
{ return CHAR(div_char (data, x2.data));}

inline BOOL CHAR :: is_gr (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline BOOL CHAR :: operator > (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline BOOL CHAR :: is_le (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline BOOL CHAR :: operator <= (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline CHAR CHAR :: mod (const CHAR & x2)
{ return CHAR(mod_char (data, x2.data));}

inline CHAR & CHAR :: operator %= (const CHAR & x2)
{ data = mod_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator % (const CHAR & x2) const
{ return CHAR(mod_char (data, x2.data));}

inline CHAR CHAR :: succ ()
{ return CHAR(succ_char (data));}

inline CHAR & CHAR :: operator ++ ()
{ data = succ_char (data); return *this;}

inline CHAR CHAR :: operator ++ (int)
{ CHAR tmp=*this; { data = succ_char (data);}; return tmp; }

inline CHAR CHAR :: plus (const CHAR & x2)
{ return CHAR(plus_char (data, x2.data));}

inline CHAR & CHAR :: operator += (const CHAR & x2)
{ data = plus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator + (const CHAR & x2) const
{ return CHAR(plus_char (data, x2.data));}

inline CHAR CHAR :: times (const CHAR & x2)
{ return CHAR(times_char (data, x2.data));}

inline CHAR & CHAR :: operator *= (const CHAR & x2)
{ data = times_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator * (const CHAR & x2) const
{ return CHAR(times_char (data, x2.data));}

inline BOOL CHAR :: is_ge (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline BOOL CHAR :: operator >= (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline BOOL CHAR :: is_lt (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: operator < (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: is_eq (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator == (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator != (const CHAR & x2) const
{ return BOOL((Bool)! is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator ! () const
{ return BOOL((Bool)! is_eq_char (data,((Char)0)));}

inline CHAR CHAR :: pred ()
{ return CHAR(pred_char (data));}

inline CHAR & CHAR :: operator -- ()
{ data = pred_char (data); return *this;}

inline CHAR CHAR :: operator -- (int)
{ CHAR tmp=*this; { data = pred_char (data);}; return tmp; }

inline CHAR CHAR :: copy () const
{ return CHAR(copy_char (data));}
inline BOOL ITER_POPULATION :: is_empty ()
{ return BOOL(is_empty_iter_population (&(data)));}

inline BOOL ITER_POPULATION :: operator ! ()
{ return BOOL(! is_empty_iter_population (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_POPULATION :: ITER_POPULATION (POPULATION x1)
{ data = mk_iter_population (x1.data);}
inline CHROMOSOM ITER_POPULATION :: sel ()
{ return CHROMOSOM(sel_iter_population (&(data)));}
inline void ITER_POPULATION :: next ()
{ next_iter_population (&(data));}

inline void ITER_POPULATION :: operator ++ ()
{ next_iter_population (&(data));}

inline void ITER_POPULATION :: operator ++ (int)
{ next_iter_population (&(data));}
inline BOOL ITER_CHROMOSOM :: is_empty ()
{ return BOOL(is_empty_iter_chromosom (&(data)));}

inline BOOL ITER_CHROMOSOM :: operator ! ()
{ return BOOL(! is_empty_iter_chromosom (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_CHROMOSOM :: ITER_CHROMOSOM (CHROMOSOM x1)
{ data = mk_iter_chromosom (x1.data);}
inline REAL ITER_CHROMOSOM :: sel ()
{ return REAL(sel_iter_chromosom (&(data)));}
inline void ITER_CHROMOSOM :: next ()
{ next_iter_chromosom (&(data));}

inline void ITER_CHROMOSOM :: operator ++ ()
{ next_iter_chromosom (&(data));}

inline void ITER_CHROMOSOM :: operator ++ (int)
{ next_iter_chromosom (&(data));}
inline BOOL ITER_ZEILE :: is_empty ()
{ return BOOL(is_empty_iter_zeile (&(data)));}

inline BOOL ITER_ZEILE :: operator ! ()
{ return BOOL(! is_empty_iter_zeile (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_ZEILE :: ITER_ZEILE (ZEILE x1)
{ data = mk_iter_zeile (x1.data);}
inline SPALTE ITER_ZEILE :: sel ()
{ return SPALTE(sel_iter_zeile (&(data)));}
inline void ITER_ZEILE :: next ()
{ next_iter_zeile (&(data));}

inline void ITER_ZEILE :: operator ++ ()
{ next_iter_zeile (&(data));}

inline void ITER_ZEILE :: operator ++ (int)
{ next_iter_zeile (&(data));}
inline BOOL ITER_SPALTE :: is_empty ()
{ return BOOL(is_empty_iter_spalte (&(data)));}

inline BOOL ITER_SPALTE :: operator ! ()
{ return BOOL(! is_empty_iter_spalte (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_SPALTE :: ITER_SPALTE (SPALTE x1)
{ data = mk_iter_spalte (x1.data);}
inline REAL ITER_SPALTE :: sel ()
{ return REAL(sel_iter_spalte (&(data)));}
inline void ITER_SPALTE :: next ()
{ next_iter_spalte (&(data));}

inline void ITER_SPALTE :: operator ++ ()
{ next_iter_spalte (&(data));}

inline void ITER_SPALTE :: operator ++ (int)
{ next_iter_spalte (&(data));}
inline BOOL ITER_FITNESS :: is_empty ()
{ return BOOL(is_empty_iter_fitness (&(data)));}

inline BOOL ITER_FITNESS :: operator ! ()
{ return BOOL(! is_empty_iter_fitness (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_FITNESS :: ITER_FITNESS (FITNESS x1)
{ data = mk_iter_fitness (x1.data);}
inline REAL ITER_FITNESS :: sel ()
{ return REAL(sel_iter_fitness (&(data)));}
inline void ITER_FITNESS :: next ()
{ next_iter_fitness (&(data));}

inline void ITER_FITNESS :: operator ++ ()
{ next_iter_fitness (&(data));}

inline void ITER_FITNESS :: operator ++ (int)
{ next_iter_fitness (&(data));}
inline NAT0 STR :: len () const
{ return NAT0(len_str (data));}
inline NAT0 STR :: index (const CHAR & x2) const
{ return NAT0(index_str (data, x2.data));}
inline CHAR STR :: hd () const
{ return CHAR(hd_str (data));}

inline STR & STR :: conc (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR & STR :: operator += (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR STR :: operator + (const STR & x2) const
{ STR tmp=*this; tmp.data=conc_auto_str(tmp.data,x2.data); return tmp; }

inline CHAR STR :: sel (const NAT1 & x2) const
{ return CHAR(sel_str (data, x2.data));}
inline CHAR STR :: operator [] (const NAT1 & x2) const
{ return CHAR(sel_str (data,x2.data));}
inline void STR :: cpc (char * x2) const
{ cpc_str (data,x2);}
inline STR :: STR (char * x1)
{ data = mkc_str (x1);}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */
inline STR & STR :: ovwrt1 (const NAT1 & x2, const CHAR & x3)
{ data = ovwrt1_str (data, x2.data, x3.data); return *this;}
inline STR :: STR (const CHAR & x1, const NAT0 & x2)
{ data = mkn_str (x1.data, x2.data);}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 POPULATION :: len () const
{ return NAT0(len_population (data));}

inline POPULATION & POPULATION :: appr (const CHROMOSOM & x2)
{ data = appr_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: operator += (const CHROMOSOM & x2)
{ data = appr_population (data, x2.data); return *this;}

inline POPULATION POPULATION :: operator + (const CHROMOSOM & x2) const
{ POPULATION tmp=*this; tmp.data=appr_population(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline POPULATION & POPULATION :: appl (const CHROMOSOM & x1)
{ data = appl_population (x1.data, data); return *this;}
inline POPULATION operator + (const CHROMOSOM & x1, POPULATION & x2)
{POPULATION tmp = x2; tmp.data = appl_population(x1.data, tmp.data); return tmp;}

inline BOOL POPULATION :: is_empty () const
{ return BOOL(is_empty_population (data));}

inline BOOL POPULATION :: operator ! () const
{ return BOOL(! is_empty_population (data));}

inline NAT0 POPULATION :: index (const CHROMOSOM & x2) const
{ return NAT0(index_population (data, x2.data));}
inline void POPULATION :: fpr (ostream & x1) const
{ fpr_population (x1, data);}
inline ostream & operator << (ostream & x1, const POPULATION & x2)
{ fpr_population (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline POPULATION & POPULATION :: rmv1 (const NAT1 & x2)
{ data = rmv1_population (data, x2.data); return *this;}
inline POPULATION :: POPULATION (const NILETC & x1)
{ data = mk_empty_population ();}
inline CHROMOSOM POPULATION :: hd () const
{ return CHROMOSOM(hd_population (data));}

inline POPULATION & POPULATION :: conc (const POPULATION & x2)
{ data = conc_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: operator += (const POPULATION & x2)
{ data = conc_population (data, x2.data); return *this;}

inline POPULATION POPULATION :: operator + (const POPULATION & x2) const
{ POPULATION tmp=*this; tmp.data=conc_population(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline POPULATION & POPULATION :: tl ()
{ data = tl_population (data); return *this;}
inline CHROMOSOM POPULATION :: sel (const NAT1 & x2) const
{ return CHROMOSOM(sel_population (data, x2.data));}
inline CHROMOSOM POPULATION :: operator [] (const NAT1 & x2) const
{ return CHROMOSOM(sel_population (data,x2.data));}
inline POPULATION :: POPULATION (const CHROMOSOM & x1)
{ data = mk1_population (x1.data);}

inline BOOL CHROMOSOM :: is_eq (const CHROMOSOM & x2) const
{ return BOOL(is_eq_chromosom (data, x2.data));}

inline BOOL CHROMOSOM :: operator == (const CHROMOSOM & x2) const
{ return BOOL(is_eq_chromosom (data, x2.data));}

inline BOOL CHROMOSOM :: operator != (const CHROMOSOM & x2) const
{ return BOOL((Bool)! is_eq_chromosom (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 CHROMOSOM :: len () const
{ return NAT0(len_chromosom (data));}

inline CHROMOSOM & CHROMOSOM :: appr (const REAL & x2)
{ data = appr_chromosom (data, x2.data); return *this;}

inline CHROMOSOM & CHROMOSOM :: operator += (const REAL & x2)
{ data = appr_chromosom (data, x2.data); return *this;}

inline CHROMOSOM CHROMOSOM :: operator + (const REAL & x2) const
{ CHROMOSOM tmp=*this; tmp.data=appr_chromosom(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline CHROMOSOM & CHROMOSOM :: appl (const REAL & x1)
{ data = appl_chromosom (x1.data, data); return *this;}
inline CHROMOSOM operator + (const REAL & x1, CHROMOSOM & x2)
{CHROMOSOM tmp = x2; tmp.data = appl_chromosom(x1.data, tmp.data); return tmp;}

inline BOOL CHROMOSOM :: is_empty () const
{ return BOOL(is_empty_chromosom (data));}

inline BOOL CHROMOSOM :: operator ! () const
{ return BOOL(! is_empty_chromosom (data));}

inline CHROMOSOM & CHROMOSOM :: ovwrt1 (const NAT1 & x2, const REAL & x3)
{ data = ovwrt1_chromosom (data, x2.data, x3.data); return *this;}
inline void CHROMOSOM :: fpr (ostream & x1) const
{ fpr_chromosom (x1, data);}
inline ostream & operator << (ostream & x1, const CHROMOSOM & x2)
{ fpr_chromosom (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CHROMOSOM & CHROMOSOM :: sub_tup (const NAT1 & x2, const NAT0 & x3)
{ data = sub_tup_chromosom (data, x2.data, x3.data); return *this;}
inline CHROMOSOM :: CHROMOSOM (const NILETC & x1)
{ data = mk_empty_chromosom ();}
inline REAL CHROMOSOM :: hd () const
{ return REAL(hd_chromosom (data));}

inline CHROMOSOM & CHROMOSOM :: conc (const CHROMOSOM & x2)
{ data = conc_chromosom (data, x2.data); return *this;}

inline CHROMOSOM & CHROMOSOM :: operator += (const CHROMOSOM & x2)
{ data = conc_chromosom (data, x2.data); return *this;}

inline CHROMOSOM CHROMOSOM :: operator + (const CHROMOSOM & x2) const
{ CHROMOSOM tmp=*this; tmp.data=conc_chromosom(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOM & CHROMOSOM :: tl ()
{ data = tl_chromosom (data); return *this;}
inline REAL CHROMOSOM :: sel (const NAT1 & x2) const
{ return REAL(sel_chromosom (data, x2.data));}
inline REAL CHROMOSOM :: operator [] (const NAT1 & x2) const
{ return REAL(sel_chromosom (data,x2.data));}
inline CHROMOSOM :: CHROMOSOM (const REAL & x1)
{ data = mk1_chromosom (x1.data);}

/* === Member function 'copy' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline NAT0 ZEILE :: len () const
{ return NAT0(len_zeile (data));}

inline ZEILE & ZEILE :: appr (const SPALTE & x2)
{ data = appr_zeile (data, x2.data); return *this;}

inline ZEILE & ZEILE :: operator += (const SPALTE & x2)
{ data = appr_zeile (data, x2.data); return *this;}

inline ZEILE ZEILE :: operator + (const SPALTE & x2) const
{ ZEILE tmp=*this; tmp.data=appr_zeile(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline ZEILE & ZEILE :: appl (const SPALTE & x1)
{ data = appl_zeile (x1.data, data); return *this;}
inline ZEILE operator + (const SPALTE & x1, ZEILE & x2)
{ZEILE tmp = x2; tmp.data = appl_zeile(x1.data, tmp.data); return tmp;}

inline BOOL ZEILE :: is_empty () const
{ return BOOL(is_empty_zeile (data));}

inline BOOL ZEILE :: operator ! () const
{ return BOOL(! is_empty_zeile (data));}

inline void ZEILE :: fpr (ostream & x1) const
{ fpr_zeile (x1, data);}
inline ostream & operator << (ostream & x1, const ZEILE & x2)
{ fpr_zeile (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline ZEILE :: ZEILE (const NILETC & x1)
{ data = mk_empty_zeile ();}
inline SPALTE ZEILE :: hd () const
{ return SPALTE(hd_zeile (data));}

inline ZEILE & ZEILE :: conc (const ZEILE & x2)
{ data = conc_zeile (data, x2.data); return *this;}

inline ZEILE & ZEILE :: operator += (const ZEILE & x2)
{ data = conc_zeile (data, x2.data); return *this;}

inline ZEILE ZEILE :: operator + (const ZEILE & x2) const
{ ZEILE tmp=*this; tmp.data=conc_zeile(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline ZEILE & ZEILE :: tl ()
{ data = tl_zeile (data); return *this;}
inline SPALTE ZEILE :: sel (const NAT1 & x2) const
{ return SPALTE(sel_zeile (data, x2.data));}
inline SPALTE ZEILE :: operator [] (const NAT1 & x2) const
{ return SPALTE(sel_zeile (data,x2.data));}
inline ZEILE :: ZEILE (const SPALTE & x1)
{ data = mk1_zeile (x1.data);}

/* === Member function 'copy' not required for automem implementations === */
inline SPALTE :: SPALTE (const REAL & x1)
{ data = mk1_spalte (x1.data);}

inline REAL SPALTE :: sel (const NAT1 & x2) const
{ return REAL(sel_spalte (data, x2.data));}
inline REAL SPALTE :: operator [] (const NAT1 & x2) const
{ return REAL(sel_spalte (data,x2.data));}
inline SPALTE & SPALTE :: tl ()
{ data = tl_spalte (data); return *this;}

/* Member function 'del1' not required for automem implementations */

inline SPALTE & SPALTE :: conc (const SPALTE & x2)
{ data = conc_spalte (data, x2.data); return *this;}

inline SPALTE & SPALTE :: operator += (const SPALTE & x2)
{ data = conc_spalte (data, x2.data); return *this;}

inline SPALTE SPALTE :: operator + (const SPALTE & x2) const
{ SPALTE tmp=*this; tmp.data=conc_spalte(tmp.data,x2.data); return tmp; }

inline REAL SPALTE :: hd () const
{ return REAL(hd_spalte (data));}
inline SPALTE :: SPALTE (const NILETC & x1)
{ data = mk_empty_spalte ();}
inline void SPALTE :: fpr (ostream & x1) const
{ fpr_spalte (x1, data);}
inline ostream & operator << (ostream & x1, const SPALTE & x2)
{ fpr_spalte (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BOOL SPALTE :: is_empty () const
{ return BOOL(is_empty_spalte (data));}

inline BOOL SPALTE :: operator ! () const
{ return BOOL(! is_empty_spalte (data));}

inline SPALTE & SPALTE :: appl (const REAL & x1)
{ data = appl_spalte (x1.data, data); return *this;}
inline SPALTE operator + (const REAL & x1, SPALTE & x2)
{SPALTE tmp = x2; tmp.data = appl_spalte(x1.data, tmp.data); return tmp;}

/* Member function 'copy1' not required for automem implementations */

inline SPALTE & SPALTE :: appr (const REAL & x2)
{ data = appr_spalte (data, x2.data); return *this;}

inline SPALTE & SPALTE :: operator += (const REAL & x2)
{ data = appr_spalte (data, x2.data); return *this;}

inline SPALTE SPALTE :: operator + (const REAL & x2) const
{ SPALTE tmp=*this; tmp.data=appr_spalte(tmp.data,x2.data); return tmp; }

inline NAT0 SPALTE :: len () const
{ return NAT0(len_spalte (data));}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline NAT0 FITNESS :: len () const
{ return NAT0(len_fitness (data));}

inline FITNESS & FITNESS :: appr (const REAL & x2)
{ data = appr_fitness (data, x2.data); return *this;}

inline FITNESS & FITNESS :: operator += (const REAL & x2)
{ data = appr_fitness (data, x2.data); return *this;}

inline FITNESS FITNESS :: operator + (const REAL & x2) const
{ FITNESS tmp=*this; tmp.data=appr_fitness(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline FITNESS & FITNESS :: appl (const REAL & x1)
{ data = appl_fitness (x1.data, data); return *this;}
inline FITNESS operator + (const REAL & x1, FITNESS & x2)
{FITNESS tmp = x2; tmp.data = appl_fitness(x1.data, tmp.data); return tmp;}

inline BOOL FITNESS :: is_empty () const
{ return BOOL(is_empty_fitness (data));}

inline BOOL FITNESS :: operator ! () const
{ return BOOL(! is_empty_fitness (data));}

inline void FITNESS :: fpr (ostream & x1) const
{ fpr_fitness (x1, data);}
inline ostream & operator << (ostream & x1, const FITNESS & x2)
{ fpr_fitness (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline FITNESS & FITNESS :: rmv1 (const NAT1 & x2)
{ data = rmv1_fitness (data, x2.data); return *this;}
inline FITNESS :: FITNESS (const NILETC & x1)
{ data = mk_empty_fitness ();}
inline REAL FITNESS :: hd () const
{ return REAL(hd_fitness (data));}

inline FITNESS & FITNESS :: conc (const FITNESS & x2)
{ data = conc_fitness (data, x2.data); return *this;}

inline FITNESS & FITNESS :: operator += (const FITNESS & x2)
{ data = conc_fitness (data, x2.data); return *this;}

inline FITNESS FITNESS :: operator + (const FITNESS & x2) const
{ FITNESS tmp=*this; tmp.data=conc_fitness(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline FITNESS & FITNESS :: tl ()
{ data = tl_fitness (data); return *this;}
inline REAL FITNESS :: sel (const NAT1 & x2) const
{ return REAL(sel_fitness (data, x2.data));}
inline REAL FITNESS :: operator [] (const NAT1 & x2) const
{ return REAL(sel_fitness (data,x2.data));}
inline FITNESS :: FITNESS (const REAL & x1)
{ data = mk1_fitness (x1.data);}

/* ------- PHASEEND ------------------ */

#endif
